<?php
/* 
 * 
 * Copyright (C) 2006, 2007,2008  Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The author can be contacted at: 
 *  [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */

function _semantic_search_set_constants() {
  $semantic_search_protocol = ($_SERVER['HTTPS']) ? 'https://' : 'http://';
  
  /**
  * base URL for semantic_search in drupal. 
  * */
  if (!defined('SEMANTIC_SEARCH_BASE_URL')) define('SEMANTIC_SEARCH_BASE_URL', '');
  
  /**
   * full url to arrive at the semantic_search home
   * */
  define('SEMANTIC_SEARCH_HOME_URL', '' . _BASE_URL . '/' . SEMANTIC_SEARCH_BASE_URL . '/');

  //Behagior settings
  //get each of these $tid's parents although this creates reduntant data
  // this is done in place of a RDF store's lack of class inference 
  // sesame's inference abilities are not generallyused, so you would not likely need to change this
  define('SEMANTIC_SEARCH_TAXONOMY_IMPORT_INFERENCE', true);

  //URL constants
  define('SEMANTIC_SEARCH_ADMIN_HOME', $semantic_search_protocol . $_SERVER['HTTP_HOST'] . '/admin/semantic_search');
  define('SEMANTIC_SEARCH_ADMIN_DATA_HOME', SEMANTIC_SEARCH_ADMIN_HOME . '/data');
  define('SEMANTIC_SEARCH_ADMIN_PROPERTIES_HOME', SEMANTIC_SEARCH_ADMIN_HOME . '/properties');
  define('SEMANTIC_SEARCH_ADMIN_CATEGORIES_HOME', SEMANTIC_SEARCH_ADMIN_HOME . '/categories');
  define('SEMANTIC_SEARCH_ADMIN_EXPORT_HOME', SEMANTIC_SEARCH_ADMIN_HOME . '/export');
  define('SEMANTIC_SEARCH_ADMIN_IMPORT_HOME', SEMANTIC_SEARCH_ADMIN_HOME . '/import');

  //RPC constants
  define('SEMANTIC_SEARCH_JSRPC_PATH', $semantic_search_protocol . $_SERVER['HTTP_HOST'] . '/' . SEMANTIC_SEARCH_JSRPC_PATH_PREFIX);
  define('SEMANTIC_SEARCH_JSRPC_ADMIN_PATH', $semantic_search_protocol . $_SERVER['HTTP_HOST'] . '/' . SEMANTIC_SEARCH_JSRPC_ADMIN_PATH_PREFIX); // url(SEMANTIC_SEARCH_JSRPC_ADMIN_PATH_PREFIX,null,null,true));

  //TODO check that each signal is unique
}

//MESSAGE PASSING SIGNALS
define('SEMANTIC_SEARCH_CREATE_OBJECT_SIGNAL', 1890);
define('SEMANTIC_SEARCH_CREATE_OBJECT_SIGNAL_STEP_ONE', 929);
define('SEMANTIC_SEARCH_CREATE_PROPERTY_SIGNAL', 1999);
define('SEMANTIC_SEARCH_EDIT_PROPERTY_SIGNAL', 19987);
define('SEMANTIC_SEARCH_DELETE_PROPERTY_SIGNAL', 23897);
define('SEMANTIC_SEARCH_EDIT_TWO_PROPERTY_SIGNAL', 22897);
define('SEMANTIC_SEARCH_CREATE_CATEGORY_SIGNAL', 10983);
define('SEMANTIC_SEARCH_EDIT_CATEGORY_SIGNAL', 98653);

define('SEMANTIC_SEARCH_EXPORT_DOWNLOAD_SIGNAL', 13897791);
define('SEMANTIC_SEARCH_EXPORT_PRINT_SIGNAL', 2378927);

// import choices
define('SEMANTIC_SEARCH_IMPORT_SIGNAL_SYNC_DUP_OLD', 549789);
define('SEMANTIC_SEARCH_IMPORT_SIGNAL_SYNC_NO_DUP_OLD', 243423);
define('SEMANTIC_SEARCH_IMPORT_SIGNAL_SYNC_NO_DUP_NEW', 2847526845);
define('SEMANTIC_SEARCH_IMPORT_SIGNAL_NO_OLD', 2873659284);

// notify that the signal is switched
define('SEMANTIC_SEARCH_CRUD_REQUEST_SIGNAL', 'ncrs');

define('SEMANTIC_SEARCH_PAGINATION_SIGNAL', 'pgn');

/**
* prefixes to convert Drupal IDs to SEMANTIC_SEARCH ids
*/
define('SEMANTIC_SEARCH_TID_PREFIX', 'tid');
define('SEMANTIC_SEARCH_VID_PREFIX', 'vid');

define('SEMANTIC_SEARCH_JSRPC_PATH_PREFIX', 'semantic_search_ajax/search');
define('SEMANTIC_SEARCH_JSRPC_ADMIN_PATH_PREFIX', 'semantic_search_ajax/admin');

//default admin home
define('SEMANTIC_SEARCH_ADMIN_HOME', 'admin/semantic_search');

/**
* DRUPAL VERSION
* */
define('SEMANTIC_SEARCH_IS_DRUPAL_5', true);

/**
* The location of the semantic_search include files
* */
define('SEMANTIC_SEARCH_INCLUDE_LOCATION', SEMANTIC_SEARCH_LOCATION . 'includes/');

/**
 * The location of the CSS file that will be read through php
 * This is done to account for various CMS's which may not provide
 * a conistent mechanism to give a URL location for the CSS.
 * */
define('CSS_LOCATION', SEMANTIC_SEARCH_LOCATION . 'css/');
