<?php

/**
 * handles functions related to URL, POST, and SESSION retrieval
 * STATE handling and IO
 * for SONIA
 *
 * @license GPLv2
 * @license 2006 KBCMS LLC
 * @author  Jonathan Hendler
 * @package SONIA
 * @version 0.3
 * */

interface SONIA_IO_API {

    ////////////////////////////////////////////////////////////////////////////
    // Filesystem
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Functionality for logging Errors
     * @param string message to be logged
     * */
    public function logError($message);

    /**
     * 
     * function for errors
     * 
     * @param string message to be logged
     * @param int error level (standard PHP int constants) 
     * 
     * */
    public function throwError($message, $error_level = E_USER_ERROR);

    ////////////////////////////////////////////////////////////////////////////
    // Import and Export
    ////////////////////////////////////////////////////////////////////////////
    /**
     * import RDF from a file, remote or local
     * 
     * @param string filename is the name of the file
     * @param string url the remote location of the file or path
     * */
    public function importRDF($filename, $url = null, $model_name = null);

    /**
     * export a portion of the SEMANTIC_SEARCH RDF data to a file
     * */
    public function exportRDF($filename, $path = null, $model_name = null);

    //---------------------------------------------------------------------------
    /**
     * helper function for retrieving the integer value of the pagination
     * @return int the begin page
     * */
    //---------------------------------------------------------------------------
    public static function getPaginationBegin();

    ////////////////////////////////////////////////////////////////////////////
    // URL
    ////////////////////////////////////////////////////////////////////////////
    /**
     * 
     * */
    public function setRequest($request);
    // public function setSession($session);

    /**
     * 
     * */
    public function getRequestValues();

    /**
     * 
     * */
    public function setSearchParams($request_param);


    /**
     * 
     * */
    public function doSearch();

    /**
     * 
     * */
    public function doCRUD();

} //end interface
