<?php
/*
  (c) 2007 - Jonathan Hendler All rights Reserved
  SONIA Sesame is a HTTP client for Sesame using the Zend Platform Library

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
 
/**
 * This is the HTTP server for the Sesame Caucho class of SONIA
 * 
 * This is only tested with Sesame 2.0 beta 5 as of this writing.
 * 
 * You need to configure 
 * 
 * examples
 *  $store = 'remote';
 	 $repo = 'http://localhost:8080/openrdf-http-server-2.0-beta5::bigtest';
 	 $store = 'memory';
 	 $repo = '/Users/jonathanhendler/Library/Application Support/Aduna/OpenRDF Sesame/repositories/bigtest/';
 * 
 * @version 0.2
 * @package SONIA
 * @author  Jonathan Hendler [jonathan dot hendler (at) gmail dot com]
 * @license GPLv3 or higher
 *  
 * @link http://framework.zend.com the Zend Framework
 * @link http://www.openrdf.org sesame
 * @link http://quercus.caucho.com/quercus-3.1/doc/quercus-java-integration.xtp
 * 
 * @todo clear context function (erase all)
 * 
 * */
 
 /**
  * This file contains the configuration items you need on your server
  * you must create it from config.php.sample
  * */
  require 'config.php';
  

 //NOTE security comes from making this url accessible via localhost only!!!
 // Sesame does have settings for read only
  if (isset($_GET['clear_cache'])){
     apc_delete('$sonia_sesame_caucho');
	   apc_delete('$sonia_sesame_config');
	   print 123;
	   exit;
  } 
  
  //NOTE security comes from making this url accessible via localhost only!!!
  // Sesame does have settings for read only
  if (isset($_POST['args']) || isset ($_GET['updateStatement']) ){
	 require_once 'sonia.caucho_sesame.class.inc';
	 $start = _microtime();
	 global $sonia_sesame_caucho;
	 if (!SESAME_USE_APC ) {
	   //apc_clear_cache();
	    apc_delete('$sonia_sesame_caucho');
	    apc_delete('$sonia_sesame_config');
	 }
	   
	 
	 
	 $sonia_sesame_caucho = (SESAME_USE_APC && empty($sonia_sesame_caucho)) ? apc_fetch('$sonia_sesame_caucho'):null;
   $sonia_sesame_config = md5(SESAME_REPO_CONTEXT.SESAME_REPO_TYPE.SESAME_REPO_DIRECTORY_OR_URL);
	 $config = (SESAME_USE_APC) ? apc_fetch('$sonia_sesame_config'): null;
	 //cache if the config changes or there is no store
	 if (empty($sonia_sesame_caucho) || ($sonia_sesame_config!=$config) || !SESAME_USE_APC){
	   $sonia_sesame_caucho = new SONIA_Sesame_Caucho(SESAME_REPO_CONTEXT,SESAME_REPO_DIRECTORY_OR_URL,SESAME_REPO_TYPE,SESAME_REPO_DEBUG,SESAME_REPO_LOFGILE_LOCATION );
	   if (SESAME_USE_APC) {
	   	 apc_store('$sonia_sesame_caucho', $sonia_sesame_caucho);
	     apc_store('$sonia_sesame_config', $sonia_sesame_config);
	   }
	 }
	 
	 try{
		 if (isset ($_GET['updateStatement'])){
		 	// $statements = unserialize(base64_decode(rawurldecode($args)));
		 	// $clear = (!empty($args['clear'])) ?$args['clear']:null;
		 	 //$add = (!empty($args['add'])) ?$args['add']:null;
		 	 
		 	 ///////////////////////////////////////////
		 	 //TODO add a thread queue so this is faster
		 	 //make main class synchronized
		 	 
		 	 $s = (!empty($_GET['s']))? rawurldecode($_GET['s']): null; 
		 	 $p = (!empty($_GET['p']))? rawurldecode($_GET['p']): null; 
		 	 $o = (!empty($_GET['o']))? rawurldecode($_GET['o']): null; 
		 	 $is_literal = (!empty($_GET['is_literal']))? rawurldecode($_POST['is_literal']): null; 
		 	 
		 	 $as = (!empty($_GET['as']))? rawurldecode($_GET['as']): null; 
		 	 $ap = (!empty($_GET['ap']))? rawurldecode($_GET['ap']): null; 
		 	 $ao = (!empty($_GET['ao']))? rawurldecode($_GET['ao']): null; 
		 	 $ais_literal = (!empty($_GET['ais_literal']))? rawurldecode($_GET['ais_literal']): null;  
		 	 
		 	  //print $s.' HI '.$p.' HI '.$o.' HI '." $as,$ap,$ao,$ais_literal" ;
		 	  //$results =json_encode(prep_json($_GET));
 
		 	 $results = $sonia_sesame_caucho->store->SesamePHP_updateStatement($s,$p,$o,$is_literal,$as,$ap,$ao,$ais_literal);
		 } else if (isset ($_POST['statementExists'])){
		 	$args = $_POST['args'];
		 	// $statements = unserialize(rawurldecode($args));
		  // $results =   $sonia_sesame_caucho->store->SesamePHP_statementExists($statements);
		 }else{
		   $args = $_POST['args'];
			 $results = $sonia_sesame_caucho->get($args, null);
		 }
	 } catch (Exception $e){
	    print json_encode('SESAME/PHP: ERROR: '.print_r($e,1));
	 }
	 $end = _microtime();
	 
	// print ' OVERALL TOTAL '.($end-$start);
	 //$results['total_time'] = $total;
	 // print_R($results);
	 try{
	   print json_encode(prep_json($results));
	 } catch (Exception $e){
	    print json_encode('ERROR: '.print_r($e,1));
	 }
	  
 } else {
   print json_encode('To query the server set POST with "args".');
 }
 
 /**
  * workaround for bug http://bugs.caucho.com/view.php?id=1998
  * rahashes the array
  * */
 function prep_json($args){
 	 if(is_array($args)){
 	 	 $return_array = array();
 	   foreach($args as $key=>$value){
 	   	 $value = ($value === null) ? '' : $value;
 	     $return_array[$key] = prep_json($value);
 	   }
 	   return $return_array;
 	 } else {
 	   return $args;
 	 }
 }
 
 
?>
