<?php

/**
 * This file contains constants that you shouldn't need to change.
 * 
 * @license GPLv2
 * @license 2006 KBCMS LLC
 * @author  Jonathan Hendler
 * @package SONIA
 * @version 0.7
 * */

/***
 * should be "edit" for Drupal
 * change name for semantic_search
 * @todo move out of SONIA into SEMANTIC_SEARCH
 * */
define('SONIA_FORM_ARRAY_PREFIX','edit');

//NUmeric
/**
 * This number is the maximum size of a value which will
 * be used as a an array key. for example:
 *   $value = 'Hello, How are you, [... plus 1000 chars]';
 *   $key = substr($value,SONIA_MAX_VALUE_SIZE_AS_KEY);
 *   $array[$key]['value'] = $value;
 * */
define('SONIA_MAX_VALUE_SIZE_AS_KEY', 250);


/**
 * shuts the cache on and off for debugging purposes
 * */
define('SONIA_USE_CACHE',false);

/**
 * for mysql 4 this should 255
 * for mysql 5 this should be 512
 * */
define('SONIA_CACHE_KEY_LENGTH',255);
//SIGNALS
// generally these can same the same. More secure if it's different for each install

/**
 * URL param to signal that a search has been submitted and to build a query
 * */
define('SONIA_SEARCH_SUBMIT_SIGNAL', 'sesu');

//what signals sonia that a CRUD request has been sent
define('SONIA_CRUD_REQUEST_SIGNAL', 'scrd');
define('SONIA_CRUD_ACTION_SIGNAL', 'scrda');
define('SONIA_CRUD_UPDATE_SIGNAL', 'upt');
define('SONIA_CRUD_CREATE_SIGNAL', 'crt');
define('SONIA_CRUD_DELETE_SIGNAL', 'dlt');
define('SONIA_CRUD_CREATE_OBJECT_SIGNAL', 'scrca');
define('SONIA_CRUD_DELETE_OBJECT_SIGNAL', 'faiouadf');
define('SONIA_NEWSEARCH_SIGNAL', 'newsearch');

define('SONIA_SEARCH_PARAMS_SIGNAL', 'search_params');

define('SONIA_CRUD_SUBJECT', 'scs');
define('SONIA_CRUD_PREDICATE', 'scp');
define('SONIA_CRUD_OBJECT', 'sco');
define('SONIA_CRUD_OLD_OBJECT', 'scoo'); //old object
//END signals 

//RDF DEFINITIONS
//RDF and RDFS constants

define('SONIA_AUTO_ID_PREFIX', 'id');

//MISC
define('SONIA_RDF_IRI_PROPERTIES_TITLE', 'Property');
define('SONIA_RDF_IRI_OBJECTS_TITLE', 'Object');
define('SONIA_RDF_IRI_CLASS_TITLE', 'Class');
define('SONIA_RDF_IRI_FILE_TITLE', 'File');

//IRIs and URIs
define('SONIA_RDF_URI', 'http://www.w3.org/1999/02/22-rdf-syntax-ns#');
define('SONIA_RDFS_URI', 'http://www.w3.org/2000/01/rdf-schema#');
define('SONIA_BASE_IRI', 'http://semanticsearch.org/namespaces/sonia/');

if (!defined('SONIA_DEFAULT_MODEL_IRI')) {
  die("SONIA_DEFAULT_MODEL_IRI needs to be defined.");
}

define('SONIA_PROPERTY_ID_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_PROPERTIES_TITLE . '#');
define('SONIA_OBJECT_ID_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_OBJECTS_TITLE . '#');
define('SONIA_CLASS_ID_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_CLASS_TITLE . '#');
define('SONIA_FILE_ID_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_FILE_TITLE . '#');

define('SONIA_FILE_TYPE_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_FILE_TITLE);
define('SONIA_FILE_CLASS_URI', SONIA_DEFAULT_MODEL_IRI . '/' . SONIA_RDF_IRI_FILE_TITLE . '#');



//define max property name
define('SONIA_MAX_ID_PROPERTY', 'sonia:soniaMaxID');
define('SONIA_CREATE_MAX_ID_PROPERTY', SONIA_BASE_IRI . '#soniaMaxID');

define('SONIA_OBJECT_COUNT_TYPE', 'sonia:soniaObjectID');
define('SONIA_CREATE_OBJECT_COUNT_TYPE', SONIA_BASE_IRI . '#soniaObjectID');

define('SONIA_MAX_ID_CLASS_TYPE', 'sonia:soniaClass');
define('SONIA_CREATE_MAX_ID_CLASS_TYPE', SONIA_BASE_IRI . '#soniaClass');

define('SONIA_MAX_ID_PROPERTY_TYPE', 'sonia:soniaPropertyID');
define('SONIA_CREATE_MAX_ID_PROPERTY_TYPE', SONIA_BASE_IRI . '#soniaPropertyID');

define('SONIA_MAX_ID_FILE_TYPE', 'sonia:soniaFileID');
define('SONIA_CREATE_MAX_ID_FILE_TYPE', SONIA_BASE_IRI . '#soniaFileID');

define('SONIA_CREATE_FILENAME', SONIA_BASE_IRI . '#soniaFileName');
define('SONIA_CREATE_FILESIZE', SONIA_BASE_IRI . '#soniaFileSize');
define('SONIA_CREATE_FILEPATH', SONIA_BASE_IRI . '#soniaFilePath');
define('SONIA_HAS_IMAGE', 'sonia:hasImage');
define('SONIA_CREATE_HAS_IMAGE', SONIA_BASE_IRI . '#hasImage');

define('SONIA_HAS_FILE', 'sonia:hasFile');
define('SONIA_CREATE_HAS_FILE', SONIA_BASE_IRI . '#hasFile');

//NOTE these only work for SPARQL, but not data creation
define('SONIA_RDF_PROPERTY_OF', 'rdfs:domain');
define('SONIA_RDF_PROPERTY_TYPE', 'rdf:Property');
define('SONIA_RDF_TYPE', 'rdf:type');
define('SONIA_RDF_ABOUT', 'rdf:about');
define('SONIA_RDFS_LABEL', 'rdfs:label');
define('SONIA_RDFS_COMMENT', 'rdfs:comment');

//RDF
define('SONIA_RDF_CREATE_PROPERTY_TYPE', SONIA_RDF_URI . 'Property');
;
define('SONIA_RDF_CREATE_TYPE', SONIA_RDF_URI . 'type');
define('SONIA_RDF_CREATE_ABOUT', SONIA_RDF_ABOUT . 'about');

//RDFS
define('SONIA_RDFS_CREATE_LABEL', SONIA_RDFS_URI . 'label');
define('SONIA_RDFS_CREATE_CLASS_TYPE', SONIA_RDFS_URI . 'Class');
define('SONIA_RDFS_CREATE_SUBCLASS', SONIA_RDFS_URI . 'subClassOf');
define('SONIA_RDF_CREATE_PROPERTY_OF', SONIA_RDFS_URI . 'domain');
define('SONIA_RDFS_CREATE_COMMENT', SONIA_RDFS_URI . 'comment');

define('SONIA_RDF_DEFAULT_ROOT_CLASS_URI', SONIA_RDFS_URI . 'Class');

//define('SONIA_EXPORT_DELIMITER', ' ||| ');
//define('SONIA_EXPORT_NEWLINE', ' ---' . "\n");

//<rdfs:subClassOf rdf:resource="&rdfs;Resource"/> root class?

///**
// * These configs are based on an abstraction of RDF
// * */
//define('SONIA_TYPE', 'Type');
//
//define('SONIA_NAME', 'hasName');
//
//define('SONIA_CONTAINER', 'Container');
//
//define('SONIA_CLASS', 'Class');
//
//define('SONIA_PROPERTY', 'Property');
//
//define('SONIA_SUBCLASS', 'SubClassOf');
//
//define('SONIA_DOMAIN', 'DomainOf');
//
//define('SONIA_DEFAULT_CATEGORY_START', 'Space');
//
//define('SONIA_NEEDS', 'needs');

/**
 * use this signal in application to signal the search type for the search box
 * for example:
 * $ptest_array = $_semantic_search_search->convertToDrupalCheckBoxArray(
    $ptest_array,
    'PARAM TEST',
    SONIA_SEARCH_PARAMETER_LABEL_RANGE_SIGNAL
  );
 * */
define('SONIA_SEARCH_CATEGORY_SIGNAL', 'cat');
/**
* use this signal in application to signal the search type for the search box
* for example:
* $ptest_array = $_semantic_search_search->convertToDrupalCheckBoxArray(
  $ptest_array,
  'PARAM TEST',
  SONIA_SEARCH_PARAMETER_LABEL_RANGE_SIGNAL
);
* */
define('SONIA_SEARCH_PARAMETER_SIGNAL', 'ps');
/**
* use this signal in application to signal the search type for the search box
* for example:
* $ptest_array = $_semantic_search_search->convertToDrupalCheckBoxArray(
  $ptest_array,
  'PARAM TEST',
  SONIA_SEARCH_PARAMETER_LABEL_RANGE_SIGNAL
);
* */
define('SONIA_SEARCH_PARAMETER_LABEL_RANGE_SIGNAL', 'plr');
/**
* use this signal in application to signal the search type for the search box
* for example:
* $ptest_array = $_semantic_search_search->convertToDrupalCheckBoxArray(
  $ptest_array,
  'PARAM TEST',
  SONIA_SEARCH_PARAMETER_LABEL_RANGE_SIGNAL
);
* */
define('SONIA_SEARCH_PARAMETER_VALUE_RANGE_SIGNAL', 'pvr');

define('SONIA_COMMENCE_SEARCH', '1980');

