<?php


/**
 * administrative functions for the SEMANTIC_SEARCH module
 * 
 * @author Jonathan Hendler 
 * @package SEMANTIC_SEARCH
 * 
 * */

/**
 * replaces missing drupal 4.6 function
 */
function message_admin_access() {
  return t('SEMANTIC_SEARCH admin access required.');
}

/**
 * creates a simple list of the navigation elements for adminstering
 * the SEMANTIC_SEARCH module's data
 * */
function _NinaAdminMenu() {
  if (!user_access("administer semantic_search")) {
    return message_admin_access();
  }

  $output = '';
  $menu_list[] = l('Export SEMANTIC_SEARCH Data', 'admin/semantic_search/export');
  //$menu_list[] = l('Import SEMANTIC_SEARCH Data', 'semantic_search/admin/import');
  $menu_list[] = l('Configure SEMANTIC_SEARCH', 'admin/semantic_search/settings');
  //$menu_list[] = l('Admin Home', 'admin/semantic_search');
  //$menu_list[] = l('Back to main Nina Application Admin Page', 'semantic_search');
  $output .= theme_item_list($menu_list);

  return t($output);
}


/**
 * Use Drupal function to trigger a download of a file
 * @todo allow user to create filename
 * 
 * */
function _semantic_search_export() {
  if (!user_access("administer semantic_search")) {
    return message_admin_access();
  }

  global $_semantic_search_search;
  if (empty ($_semantic_search_search))
    _SEMANTIC_SEARCH_INIT();

  // link to set the downlowd
  $download_link = '/'.SEMANTIC_SEARCH_ADMIN_EXPORT_HOME . '?' . SEMANTIC_SEARCH_EXPORT_DOWNLOAD_SIGNAL . '=1'; //site plus export download signal

  //link to print rdf to screen
  $print_link = '/'.SEMANTIC_SEARCH_ADMIN_EXPORT_HOME . '?' . SEMANTIC_SEARCH_EXPORT_PRINT_SIGNAL . '=1'; //site plus export download signal

  //output
  $output = '<a href="' . $download_link . '" > Download RDF File</a>';
  $output .= '<br /><a href="' . $print_link . '" > Print to screen RDF File</a>';

  if (isset ($_GET[SEMANTIC_SEARCH_EXPORT_DOWNLOAD_SIGNAL])) {
    $rdf = $_semantic_search_search->sonia->exportRDF(null);
    SONIA_H :: SendContent($rdf, 'sonia.rdf', 'text/xml+rdf');
  } else
    if (isset ($_GET[SEMANTIC_SEARCH_EXPORT_PRINT_SIGNAL])) {
      $rdf = $_semantic_search_search->sonia->exportRDF(null);
      return $output . '<br/>RDF:<br/><pre> <br/>' . nl2br(htmlentities($rdf)) . '</pre>';
    }

  return $output;
}


function semantic_search_sync_form() {
  $form = array ();
  $default_values = array ();
  global $_semantic_search_search;
  if (empty ($_semantic_search_search))
    _SEMANTIC_SEARCH_INIT();
  
  $form['rpc_sync']['BATCH-SYNC-JS'] = array (
    '#type' => 'submit',
    '#value' => 'SYNC via RPC');
    
  $form['rpc_sync']['BATCH-SYNC-JS-DIV'] = array (
    '#value' => '<div id="sem-search-batch-js" style=" background-color: #BBBBBB; font-size: larger; font-weight: bold; padding: 10px; border: 1px solid #000000; padding-left: 20px; " ></div> ');
    
  $form['data_settings'] = array (
    '#type' => 'fieldset',
    '#title' => 'Push Data',
    '#description' => t('Push to RDF store in Batches Over HTTP'),
  );
  
  $form['data_settings']['NODE_RESET'] = array (
    '#type' => 'checkbox',
    '#title' => t('<strong>Clear Search Cache and RDF data.</strong>'
  ), '#description' => t('Clear ALL the data in SEMANTIC SEARCH? - only use this when starting over!!!'), '#return_value' => 1, '#default_value' => 0,
    );
  
  $index_size = _semantic_search_node_index_count();
  $total_node_count = _semantic_search_node_total_count();
  $the_type = 'SEMANTIC_SEARCH_IMPORT_BATCH_SIZE';
  $form['data_settings'][$the_type] = array (
    '#type' => 'textfield',
    '#title' => t('Batch Size'
  ), '#description' => t('There are currently %size of %total total nodes imported this search.<br>It takes a long time to build RDF. This lets you build in batches.',
     array('%size'=>$index_size,'%total'=>$total_node_count)),
  '#default_value' => variable_get($the_type, 1000),
   );
  
  $form['end']['submit'] = array (
    '#type' => 'submit',
    '#value'=>'Sync In Batches');
  
  return $form;
    
}

/**
 * hook_submit api call
 * */
function semantic_search_sync_form_submit($form_id,$form_values){
  //node sync and reset?
  if (isset ($form_values['NODE_SYNC']) && ($form_values['NODE_SYNC'] == 1)) {
    drupal_set_message(t('Semantic Search: synchronizing'));
    _semantic_search_node_sync($form_values);
  }
}
