<?php
/*
 * Copyright (C) 2006, 2007,2008  Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The authors can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */

/**
 * the main function generating a search form
 */
function _semantic_search_search($search_form = null) {
  
  ////__nsp(' semantic_search.module _semantic_search_search() start');
  //check to see if this is the url the user intends
  //only if not RPC
  _semantic_search_check_redirect();
  //__nsp('  _semantic_search_search  start');
  global $_semantic_search_search;
  if (empty ($_semantic_search_search))
    _SEMANTIC_SEARCH_INIT();
   
  //dbg($_semantic_search_search->sonia->io->startBuildingCache($_semantic_search_search),'huh?');

  ////__nsp(' semantic_search.module (css start');
  _semantic_search_load_js_and_css();
  ////__nsp(' semantic_search.module (css end');
  $_semantic_search_search_hash = 'all' . $_semantic_search_search->search_hash;
  //__nsp(' semantic_search.module (cache start');
  $result = (SONIA_USE_CACHE) ? $_semantic_search_search->sonia->io->getCache($_semantic_search_search_hash) : null;
  //__nsp(' semantic_search.module theme("cache end');
  if (SONIA_USE_CACHE && $result !== null) {
    return $result;
  } else {
    //__nsp(' semantic_search.module enter iff');
    $vars['$do_search$'] = $_semantic_search_search->doSearch();
    $_semantic_search_search_result_found = $_semantic_search_search->searchResultsFound();
     
    $pag = $_semantic_search_search->searchPaginaton();
    $vars['$pagination$'] = theme("semantic_search_search_results_pagination", $pag);
    
    $vars['$search_results$'] = _semantic_search_SearchResults($_semantic_search_search);
    //__nsp(' semantic_search.module _semantic_search_search() _semantic_search_SearchResults( end');
    $vars['$search_jellybean$'] = _semantic_search_SearchNavigation($_semantic_search_search);
    //__nsp(' semantic_search.module _semantic_search_search() semantic_search_search begin');
    $vars['$search_form$'] = $search_form;  //;
    //__nsp(' semantic_search.module theme("semantic_search_search" end');
    $vars['$search_title$'] = (true) ? t('Search CCK nodes') : '';
    $vars['$search_results_title$'] = (!$vars['$do_search$']) ? t('Search Results') : $vars['$pagination$'];
    //dbg($_semantic_search_search_result_found,'$_semantic_search_search_result_found');
    $vars['$search_results_lower_nav$'] = (!$pag['search_results_success'] && $pag['do_search']) ? '' : $vars['$pagination$'];
    ////__nsp(' semantic_search.module theme("semantic_search" start');
    $result = theme("semantic_search", $vars);
    ////__nsp(' semantic_search.module  theme("semantic_search" end');

    if (SONIA_USE_CACHE)
      $_semantic_search_search->sonia->io->putCache($_semantic_search_search_hash, $result);
    ////__nsp(' semantic_search.module _semantic_search_search() end');
    return $result;
  }
}


/**
 * displays search results
 * */
function _semantic_search_SearchResults(& $_semantic_search_search, $not_rpc = true) {
  $html = '';
 // dbg($_semantic_search_search->searchResults($not_rpc));
  if (is_object($_semantic_search_search)) {
    db_set_active('arc');
    $html .= theme("semantic_search_search_results", $_semantic_search_search->searchResults($not_rpc));
    db_set_active('default');
    return $html;
  }
} // _SearchResults();

/**
 * wrapper for the drupal function
 * adds some extra fields
 * */
function _semantic_search_form_render($form) {
  $form = theme('semantic_search_search_form',$form);
  return drupal_get_form('_semantic_search_form_render_form', $form);
}

function _semantic_search_form_render_form($form){
  global $_semantic_search_search;
  if (empty ($_semantic_search_search))
    _SEMANTIC_SEARCH_INIT();
  if (empty($form['#action'])) $form['#action'] = urldecode($_semantic_search_search->makefullURLforRedirect());
  
  //signal that the search as commenced
  $form['extra'][SONIA_FORM_REQUEST_PREFIX . '[' . SONIA_SEARCH_SUBMIT_SIGNAL . ']'] = array (
    '#type' => 'hidden',
    '#value' => 1
  );
  
  $form['extra'][SONIA_FORM_REQUEST_PREFIX . '[' . SONIA_COMMENCE_SEARCH . ']'] = array (
    '#type' => 'hidden',
    '#value' => 1
  );
  
  return $form;
}


/**
 * any form based validation to do 
 * */
function _SEMANTIC_SEARCHSearch_validate($form_id, $form_values) {

}

/**
 * catch this form and prevent a redirect
 * 
 * @return false don't redirect
 * 
 * */
function _SEMANTIC_SEARCHSearch_submit($form_id, $form_values) {
  return false;
}

