<?php
 /*
  * 
 * Copyright (C) 2006, 2007,2008  Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The authors can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */

/**
 * check if all the js files should be included in the header
 * */ 
function _semantic_search_load_js_needed(){
  
  if( (user_access("admin semantic_search") ) ){
   
  }
  return true;
}

/**
 * load javascript for the module
 * @see _semantic_search_load_js_and_css()
 * */
function _semantic_search_load_js(){
  $path = drupal_get_path('module', 'semantic_search');
  
  $js_path = $path . '/js';
  //todo dynamically or statically combine these into one file
  drupal_add_js($js_path . '/semantic_search.contrib.js');
  drupal_add_js($js_path . '/jquery.history.js');
  drupal_add_js($js_path . '/jquery.cache.js');
  drupal_add_js($js_path . '/jquery.hook.js');
  drupal_add_js($js_path . '/sha1.js');
  drupal_add_js($js_path . '/semantic_search.helpers.js');
  //TODO only include if JS is required
  //drupal_add_js($js_path . '/semantic_search.js');
  
  if (user_access("admin semantic_search")) {
    drupal_add_js($js_path . '/semantic_search.admin.js', 'module','header', FALSE, FALSE);
    $constants = ' var SEMANTIC_SEARCH_JSRPC_ADMIN_PATH = "' . SEMANTIC_SEARCH_JSRPC_ADMIN_PATH . '"; ';
    // $js_constants = "\n" . '<script type="text/javascript">' . $constants . '</script>' . "\n";
    // now add some constants and configurations set by the server,
    // but used in the javascript
    drupal_add_js($constants,'inline', 'header', false, false);
  }
}
 
/**
* add semantic_search javascript and CSS libraries to Drupal
* */
function _semantic_search_load_js_and_css() {
  global $semantic_search_css_loaded;
  if (empty ($semantic_search_css_loaded)) {
    $semantic_search_css_loaded = true;
    global $_semantic_search_search;
   
    $path = drupal_get_path('module', 'semantic_search');
    $css_path = $path . '/css';
   
    //add js
    if (_semantic_search_load_js_needed()) {
      _semantic_search_load_js();
    }
    
    /**
    * add css  
    * */
    $css = $css_path . '/semantic_search.css';
    drupal_add_css($css);
    $css = $css_path . '/semantic_search_ajax.css';
    drupal_add_css($css);
    $semantic_search_css_loaded = true;
  }
}
 
/**
 *  checks for a variable set via javascript and decides if to do a redirect
 * */
function _semantic_search_check_redirect() {
  /*
  if (!empty ($_COOKIE['SEMANTIC_SEARCH_REDIRECT']) && empty ($_SESSION['SEMANTIC_SEARCH_REDIRECTED'])) {
    $url = $_COOKIE['SEMANTIC_SEARCH_REDIRECT'];
    unset ($_COOKIE['SEMANTIC_SEARCH_REDIRECT']);
    $_SESSION['SEMANTIC_SEARCH_REDIRECTED'] = true;

    $this_uri = url($_SERVER['REQUEST_URI'], null, null, true);
    if ($url != $this_uri) {
      unset ($_COOKIE['SEMANTIC_SEARCH_REDIRECT']);
      unset ($_SESSION['SEMANTIC_SEARCH_REDIRECTED']);
      drupal_set_header('Location: ' . $url . "\n");
    } else {
      unset ($_COOKIE['SEMANTIC_SEARCH_REDIRECT']);
      unset ($_SESSION['SEMANTIC_SEARCH_REDIRECTED']);
    }
  } else {
    unset ($_COOKIE['SEMANTIC_SEARCH_REDIRECT']);
    unset ($_SESSION['SEMANTIC_SEARCH_REDIRECTED']);
  }
  */
}
