<?php
/*
 * Copyright (C) May 2006 Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The authors can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */
 
 /**
 * function for constructing search navigation display
 * */
function _semantic_search_SearchNavigation(& $_semantic_search_search, $not_rpc = true, $toggle = true, $extra = null) {
  $html = '';

  if (is_object($_semantic_search_search)) {
    db_set_active('arc');
    $data = $_semantic_search_search->jellyBean($not_rpc, $toggle, $extra);
    db_set_active('default');
  }
  return theme("semantic_search_navigation", $data);
}
 
 /**
  * provides functions for building search navigation elements
  * */
class NinaNav{
  /**
   * creates a link that can be used to bookmark or preserver state of th search
   * */
  public static function search_link(&$search_params, $append = '') {
    return url(SEMANTIC_SEARCH_BASE_URL, SONIA_URL_H :: makeFullURLFromSearch($search_params) . $append, null, true);
  }
  
  /**
   * creates a link to reset the search
   * */
  public static function search_reset_link(&$sonia) {
   // dbg(SEMANTIC_SEARCH_BASE_URL,'SEMANTIC_SEARCH_BASE_URL');
    return url(SEMANTIC_SEARCH_BASE_URL, SONIA_URL_H :: restartSearchURL( ), null, true);
  }

}

