<?php


/*
* Copyright (C) 2007 Jonathan Hendler
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
* 
* The author can be contacted at: 
*  - [hendlerman (at) yahoo DOT com]
* 
* @license GPLv2
* @link    http://drupal.org/project/semantic_search
*/

/**
 * generate forms for adding an removing search fields
 * */
function _semantic_search_admin_form_search_fields($search_type_select, $search_id) {
  //fields
  //dbg($search_type_select, $search_id);
}

/**
 * places in semantic_search_menu to 
 * 
 * @return array search_paths
 * */
function _semantic_search_get_menus(& $items, &$searches, $may_cache) {

  if (!$may_cache) {
    //get all searches

    foreach ($searches as $key => $search) {
      $search_name = $search['name'];
      $search_path = $search['path'];
      $search_id = $search['id'];
      $search_type = $search['id'];

      $items[] = array (
        'path' => $search_path,
        'title' => t($search['title']), 
        'description' => t($search['description']), 
        'callback' => '_semantic_search_load_search', 
        'callback arguments' => array (
          $search_name,
          $search_id,
          $search_type,
        ), 
        'access' => user_access($search_name . ': access search'), 
        'weight' => $key +1, 
        'type' => MENU_LOCAL_TASK);
      }// end foreach
    } // end may_cache
}

/**
 * generate a search form
 * This is THE default search form generator
 * */
  function _semantic_search_load_search($search_name, $search_id= null,$search_type = null, $cache_stats_only = false,$rpc = false) {
    
    $data = _semantic_search_get_search_form_vars($search_name);
    
    $css_name = strtolower(trim($search_name));
    $css_name = str_replace(' ','-',$css_name);
    $css_name = str_replace('_','-',$css_name);
    $css_name = str_replace('--','-',$css_name);
    
    
    /**
    * base URL for semantic_search in drupal. 
    * */
    define('SEMANTIC_SEARCH_BASE_URL', $data['path']);
    //ahirc? _semantic_search_set_constants();
    $form['#method'] = 'get';
    $form['#action'] = '/'.$data['path']; //??
    $form['#prefix'] = '<div id="'.$css_name.'-div">';
    $form['#suffix'] = '</div>';
    
         
    $cache_stats_only = ($cache_stats_only) ? 1 : 0;
    $fields = _semantic_search_get_form_search_fields($data['id']);
    global $_semantic_search_search;
    if (empty ($_semantic_search_search))
      _SEMANTIC_SEARCH_INIT(); 
    
    $count = 0;

//TODO add $search_name hidden
    foreach($fields as $field){
      $form_element = array();
      $form_element['#type'] = $field['form_type'];
      $form_element['#query_type'] = $field['search_field_type'];
      $form_element['#multiple_facet'] = $field['multiple'];
      //$form_element['#show_in_search_count'] = $field['search_field_type'];
      $form_element['uris'][] = SONIA_H :: decodeURI($field['uris']);
      $form_element['#title'] = $field['title'];
      $form_element['#title_as_option'] = $field['title_as_option'];
      $form_element['#grand_total'] = $field['grand_total'];
      $form_element['#search_name'] = $search_name;
      $form_element['#id'] = $css_name.'-e'.$count;
      //$form_element['#top_option'] = 'national';
     
      $form['a'.$count]['#value'] = '<div class="semantic-search-form-element-wrapper">';
      $form['b'.$count] = $form_element;//$_semantic_search_search->getSearchFormElement($form_element);
      $form['c'.$count]['#value'] ='</div>';
      
      $count++;
    }
     
    //check to see if search is rpc or custom API
    if (!$rpc){
      $html = semantic_search_form_api($form);
      return _semantic_search_search($html);
    }
    else { //use rpc and return just the form and it will be sent as JSON
      return $form;
    }
    
  }
  
  
/**
 * retrieve the search form fields from the db for a search
 * 
 * */  
function _semantic_search_get_form_search_fields($search_id) {
    $return_array = array();
     $results = db_query("SELECT * FROM {semantic_search_searches_fields} WHERE sid=%d",$search_id);
     while ( $result = db_fetch_array($results)) {
       $return_array[] = $result;
     }
     return  $return_array;
}

/**
 * retrieve the search form info for a field from the db 
 * 
 * */  
function _semantic_search_get_form_search_field($field_id) {
  return db_fetch_array( db_query("SELECT * FROM {semantic_search_searches_fields} WHERE id=%d LIMIT 1",$field_id));
}


/**
 * retrieve the search form fields from the db for a search
 * can be used for insert or update
 * */  
function _semantic_search_set_form_search_fields($params) {
    $params['uris'] = base64_encode(serialize($params['uris']));
    $return_array = array();
    if (!isset($params['id'])){
      $results = db_query("INSERT INTO {semantic_search_searches_fields} ( sid , uris , form_type , search_field_type , title , description , grand_total , top_option , title_as_option )
      VALUES (
      %d,  '%s', '%s', '%s', '%s', '%s', %d, %d, %d); ",
      $params['sid'],$params['uris'],$params['form_type'],$params['search_field_type'],$params['title'],$params['description'],$params['grand_total'],$params['top_option'],$params['title_as_option']);
      drupal_set_message('Facet '.$params['title'].' added to search.');
    
    } else {
     $results = db_query("UPDATE {semantic_search_searches_fields} SET  sid = %d, , uris ='%s',  form_type= '%s', search_field_type='%s', title= '%s', description= '%s',  grand_total= %d, top_option =%d, title_as_option=%d WHERE id = %d; ",
     $params['sid'],$params['uris'],$params['form_type'],$params['search_field_type'],$params['title'],$params['description'],$params['grand_total'],$params['top_option'],$params['title_as_option'],$params['id']);
     drupal_set_message('Facet '.$params['title'].' updated.');
    }
}

/**
 * 
 * */
function _semantic_search_get_all_search_form_vars(){
   global $semantic_search_searches; //limit db calls
   
   $return_array = array();
   $results = db_query("SELECT *  FROM {semantic_search_searches}");
   while( $result = db_fetch_array($results)){
     $return_array[] = $result;
   }
   return  $return_array;
}
