<?php
/*
 * Copyright (C) 2006, 2007,2008  Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The author can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */
/**
 * semantic_search's theme function
 * */
function theme_semantic_search($vars){
  $filpath = SEMANTIC_SEARCH_LOCATION . 'html/search.htm';
  return _semantic_search_temp_template($filpath, $vars);
}


/**
 * tell us if a link is external
 * */
 function _semantic_search_external_link($url){
    return !strstr($url,_BASE_URL);
 }
 
/**
 * temp replacement for phptemplate
 * */
function _semantic_search_temp_template($filpath, $vars) {
  $text = file_get_contents($filpath);
  return str_replace(array_keys($vars), array_values($vars), $text);
}

/**
 * override this function with your own theme
 * */
function theme_semantic_search_navigation($data) {
  //data to return
  //    $data = array ();
  //    $data['results_found'] = $this->searchResultsFound();
  //    $data['is_rpc'] = !$not_rpc;
  //    $data['url'] = NinaNav :: search_link($this->search_params);
  //    $data['jellyBeanMenu'] = $this->displayJellyBeanMenu($data['url']);
  //    $data['jellyBeans'] = array (); //o key, 1 value, 2 remove link
  $html = '';
  $remove_symbol = '[X]&nbsp';
  $url = $data['url'];
  $count = 0;
  
  
  if ($data['is_rpc'] && $data['search_active']) {
    $html .= '<div class="naturalQuery" id="naturalQuery"  >';
  }

  if ($data['search_active']) {
    $html .= $data['jellyBeanMenu'];
    $html .= $data['extra'];
    $html .= '<div  id="naturalQueryContent"  >';

    foreach ($data['jellyBeans'] as $jb) {
      if ($count > 0)
        $html .= ',&nbsp;';

      $html .= '<div class="nlq" >';
      $html .= '<a href="' . $jb[2] . '" title="remove your search for ' . $jb[1] . '" onclick=" $(this).text(\'\');">' . $remove_symbol . '</a>';
      if ($jb[3]) {
        $html .= ' <strong>' . $jb[1] . '</strong>';
      } else { //is text
        $html .= ' <strong>"<em>' . $jb[1] . '</em>"</strong>';
      }
      $html .= '</div>';
      $count++;
    }

    $html .= '</div>'; //end naturalQueryContent
  }

  if ($data['is_rpc'] && $data['search_active'])
    $html .= '</div>';

  return $html;

}

/**
 * navigation elements for within the search navigation area
 * */
function theme_semantic_search_navigation_menu($data) {

  $html = '<div id="JellyBeanMenu">';
  $html .= '<div class="restartSearch" > - <a href="' . $data['restart'] . '">restart search</a></div>';
  $html .= '<div class="bookmarkSearch" > - <a href="' . $data['url'] . '">bookmark search</a></div>';

  $html .= '<div class="NinaSearchHelp" id="NinaSearchNavHelpTitle" >';
  $html .= $data['help_title'] . '</div> ';
  $html .= '<div class="NinaToolTip" id="NinaSearchNavHelp" >' . $data['help_text'] . '</div>';
  $html .= '</div>';
  return $html;
}

/**
 * @todo internationalize with t() function
 * */
function theme_semantic_search_search_results_pagination($data) {
  $html = '';
  $base_url = $data['base_url'];
  $restart_url = $data['restart_url'];

  if (!$data['search_results_success']) {
    if ($data['do_search']) {
      $html .= t('No results found, Please <a href="'.$restart_url.'" title="Restart Search">restart your search</a> or adjust your search by removing some terms.');
    }

  } else {
    if (($data['begin'] + 1) == $data['end']) {
      $html .= '<div class="results-displayed-text" >Displaying item ' . ($data['begin'] + 1) . '</div>';
    } else {
      $html .= '<div class="results-displayed-text" >Displaying items ' . ($data['begin'] + 1) . ' through ' . $data['end'] . ' (of ' . $data['total'] . ' total)</div>';
    }

    $pagination .= '<span class="semantic_searchPagination">';
    if (!empty ($data['previous_link'])) {
      $pagination .= '<a href="' . $data['previous_link'] . '">Previous</a>&nbsp;&nbsp;';
    }

    $pagination .= '&nbsp;&nbsp;';

    if (!empty ($data['next_link'])) {
      $pagination .= '<a href="' . $data['next_link'] . '">Next</a>&nbsp;&nbsp;';
    }

    $pagination .= '</span>';
    $html .= $pagination;
  }

  return $html;
}


function theme_semantic_search_search_results_row(
&$search_result, 
$show_complete_link = true,
$show_more =true,
$use_unorderd_list = false,
$show_numbers = true,
$tcount =0,
$link_class  = null,
$link_extra = null ){
  
  //sort by key
  ksort($search_result['rows']);
  $title = $search_result['#title'];
  $title_extra = (!empty($search_result['#title_extra'])) ? $search_result['#title_extra']: '';
  $result_number = $search_result['#result_number'];
  $node_url = $search_result['#node_url'];
  
  $hash = md5($node_url);
  
  if ($show_more){
    $more = '<span class="moreInfo"  onClick="semantic_searchToggle(\'hr'.$hash.'\');" ';
    $more .= '>View Profile Highlights [+/-]</span>';
  }
  
  $complete_link = ($show_complete_link)?'<div class="completeInfoLink"><a  href="'.$node_url.'" title="view complete details" >View Complete Profile >> </a></div>':'';
  
  
  $display_html = $hidden_html = $image_html = $top_html = '';
  $separator = ':&nbsp;&nbsp;';
  
  if ($use_unorderd_list) $top_html .= '<li>';
  $altclass =  ($tcount%2 == 0) ? ' searchResultAltClass ':''; 
  $top_html .= "\n".'<div class="searchResult '.$altclass.'">';
  $top_html .= $more;
  if (!$use_unorderd_list && $show_numbers) $top_html .= '<span class="number">' . $result_number . '</span>';
  
  $target = (_semantic_search_external_link($node_url) ) ? ' target="_blank" ' :'';
  $top_html .= '<div class="NinaSearchResultTitle '.$link_class.' " >'.$link_extra.'<a href="' . $node_url . '" '.$target.' >' . $title . '</a>'.$title_extra.'</div>';
  $top_html .= $complete_link;
  
  foreach($search_result['rows'] as $field){
    if (!$field['title'] && !$field['image']){
      //if type = image or file

      //add alink to field names
      $name = '<span class="semantic_searchFieldLabel">'.$field['name'].'</span>';
      $field['value'] = (!is_array($field['value'])) ?  $field['value'] : implode(', ',$field['value']);
      $temp_name = trim($field['name']);
      
      $this_separator = (empty($temp_name)) ? '&nbsp;' : $separator;
      
      if ((!$field['hidden'] || $field['searched']) && !$field['image']){
         if ($field['searched']) {
            //makes the search result show up first
            //if (isset ($this->search_params['qstring'])) $field['qstring']{
            //dbg($field['qstring'],"field['qstring']");
            
            if (!empty($field['qstring'])) {
              $search_terms = $field['qstring'];
              foreach ($search_terms as $search_term){
                if (!is_array($search_term)){
                  $field['value']= str_replace($search_term, 
                    '<span class="semantic_searchHighlightedTerm">' . $search_term . '</span>', $field['value']);
                }
                else  {
                  foreach($search_term as $search_term2)
                    $field['value']= str_replace($search_term2, 
                      '<span class="semantic_searchHighlightedTerm">' . $search_term . '</span>', $field['value']);             
                }
              }
            }
            
            $display_html .= "<div class=\"NinaSearchResultField searched\">{$name}{$this_separator}{$field['value']}</div>";
          } else  {
            $display_html .= "<div class=\"NinaSearchResultField\">{$name}{$this_separator}{$field['value']}</div>";
          }                    
      }
      else if ($show_more){
        $hidden_html .= "<div class=\"NinaSearchResultField\">{$name}{$this_separator}{$field['value']}</div>";
      }
    
    } else if ($field['image']){
        $image_html = '<img class="semantic_searchSearchResultImage" src="'.$field['value'].'" title="'.$field['name'].'" alt="'.$field['name'].'" /> ';
    }
    
    
  }
   $top_html = $image_html.$top_html;
   $final_html = $top_html.$display_html;
   if ($show_more) $final_html .='<div class="hiddenSearchResults" id="hr'.$hash.'">'.$hidden_html.'</div>';
   $final_html .='</div>';
   if ($use_unorderd_list) $final_html .= '</li>';
   
   return $final_html;
  
}

/**
 * use to alter form api data
 *  
 * */
function theme_semantic_search_search_form($data){
   return $data;
}

function theme_semantic_search_search_results($data, $unordered_list= false) {
  $not_rpc = $data['not_rpc'];
  $total   = $data['total'];
  $base_url = $data['base_url'];
  $begin = $data['begin'];
  $displayed = $data['displayed'];
  
  $html = '';
  
  //not sure 
  $the_type = 'semantic_search_display_preview_data';
  $display_all_paramter_counts = variable_get($the_type, '0');
  
  $container_type = ($unordered_list) ?'ul':'div';
  if ($not_rpc)
    $html .= '<'.$container_type.' class="searchResults" id="semantic_searchSearchResults">';

  $count = 0;
  
  if(!empty($data['search_results']) && is_array($data['search_results'])){
    
    foreach ($data['search_results'] as $search_result) {
      ++$count;
      $html .= theme("semantic_search_search_results_row",$search_result,  false,false,false,false,$count);
    }
    
  }
  
   //$html .= 'dbg '. $this->sonia->getDebugText();
  if ($not_rpc)
    $html .= '</'.$container_type.'>';

  if ($data['do_search'] && $not_rpc)
    $html .= ' <br class="brclear" /> ';
  
  return $html;
  
} //end theme_semantic_search_search_results

 
