/**
 * Jonathan Hendler
 * The author can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * there are hooks which can be called via extending functions
 * 
 * semantic_searchSearchStartedHook()
 * semantic_searchSearchCompletedHook()
 * semantic_searchSearchSuccessfulHook();
 * semantic_searchSearchRefresh();
 * 
 * simply define the above functions in the JS of an extending module
 * 
 * 
 * there are also variables which can be declared to alter behavior
 * the following creates search pagination
 * var SEMANTIC_SEARCH_JS_PAGINATION = true;
 * 
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 * 
 */

/**
 * ASAP check if there is a redirect set
 */
function checkRedirect(){
  /*  if ( Get_Cookie( 'SEMANTIC_SEARCH_REDIRECT' )){
       var new_uri = Get_Cookie( 'SEMANTIC_SEARCH_REDIRECT' );
       Delete_Cookie( 'SEMANTIC_SEARCH_REDIRECT' );
       //IE7 remote doesn't respect this
       //if (new_uri != window.location)
         //window.location = new_uri;
    }
    */
}

checkRedirect();

////settings TODO move these to settings page
var default_search_page = '/search/ahirc';
var search_home = 'http:// .net'+default_search_page;
var default_url_prefix = '/semantic_search_ajax/search';
var url_prefix = null;
//current RPC location
var rpc_uri= null;
//enable debugging messages
var semantic_search_debugging = true;
//enable benchmarking
var semantic_search_benchmarking = false;
//enable snap
var semantic_search_snap = false;

//globals /constants
/* url separator*/
var sep = '&';
//this needs to be set dynamically
//signal updates
var semantic_search_updating = true;
//signal for snap
var snapped = false;

$(document).unload(function() {  
 });

/**
 * abstraction for saving in local cache amd history
 */
function initialize() {
   $.historyInit(SEMANTIC_SEARCHTestURL);
   if (window.SEMANTIC_SEARCHHistory == undefined) window.SEMANTIC_SEARCHHistory = new Array();
}

/**
 * use javascript to set links and set paginataion links to 
 * behave as specified 
 */
function setLinks(){
   $(".bookmarkSearch a").click( function(){
       var new_uri = $(this).attr('href');
       if ($.browser.msie){
            window.external.AddFavorite(new_uri,window.title);
            window.location = new_uri;
           return false;
       }
       //else if (window.sidebar) {
       //    window.sidebar.addPanel(window.title, new_uri,'');
       //    window.location = new_uri;
       //    return false;
       //}  
       else {
           alert('Use the URL above as a link to the this page.');
           window.location = new_uri;
           return false;
       }
          
   });
   
   
   $(".semantic_searchPagination a").click( function( ){
       if ((SEMANTIC_SEARCH_JS_PAGINATION != undefined) && SEMANTIC_SEARCH_JS_PAGINATION) {
         var new_uri = $(this).attr('href');
         new_uri = new_uri.replace(default_search_page,default_url_prefix);
         semantic_searchSearchSubmitLink(new_uri);
         return false;
       }
   });  
   
   //perhaps these three can be made into one function?
   $(".NinaSearchResultTitle a").click( function( ){
       var new_uri = $(this).attr('href');
       
       var bookmark_uri = $(".bookmarkSearch a").attr('href');
       Set_Cookie( 'SEMANTIC_SEARCH_REDIRECT', bookmark_uri );
       if ($(this).attr('target') == '_blank'){
          // $(this).attr('target,');
          // window.open(new_uri,'_blank');
       } else {
           window.location = new_uri;
           return false;
       }
   });  
   
   $(".completeInfoLink a").click( function( ){
       var new_uri = $(this).attr('href');
       var bookmark_uri = $(".bookmarkSearch a").attr('href');
       Set_Cookie( 'SEMANTIC_SEARCH_REDIRECT', bookmark_uri );
       if ($(this).attr('target') == '_blank'){
           window.open(new_uri,'_blank');
       } else {
           window.location = new_uri;
       }
       return false;
   });
   
   $("._external").click( function( ){
       var new_uri = $(this).attr('href');
       var bookmark_uri = $(".bookmarkSearch a").attr('href');
       Set_Cookie( 'SEMANTIC_SEARCH_REDIRECT', bookmark_uri );
       window.location = new_uri;
       return false;
   });
}



$(document).ready(function(){
      
   //cache functions    
   window.initialize();
   
   setLinks();
   
   $("#advanced-search-box").hide();
   /* disable certain anchor tags*/
   $(".ahirc-title-link").click(function(){
       return false;
   });
   
   
   // change the href so there is no redirect or location change
   $("#ahirc-advanced-search-link").click( function (){
        $("#advanced-search-box").toggle("slow");
   	  }
	);
   
   
   $("#semantic_search-search-button").click(function (){
       
       semantic_searchSearchSubmitButton();
       return false;
   });
   
   bindToggleHelpText();
   $(".hiddenSearchResults").hide();
   
   //makes the first page accesible via back button
   setSEMANTIC_SEARCHHistory();
   
   
    
});

/**
 * a function call to embed in links so that onClick, onFocus, 
 * the links or selects can submit a search form.
 */
function semantic_searchSearchSubmitLink(uri, updateHistory) {
    //pause the history monitor
    //clearInterval( historyIntervalID ); 
    //save the rpc link for benchmarking stats and current location
    rpc_uri = uri;
    semantic_search_updating = true;
    if(updateHistory == undefined || updateHistory )setSEMANTIC_SEARCHHistory(rpc_uri);
     
    //$("#dev-studies").html('Searching...');
    $("#header").prepend('<div class="ActiveProgress" id="ActiveProgress" >  </div>');
    //$("#ahirc-results-content").html('Searching...');
    $(".semantic_searchPagination").html('');
    
    if (semantic_search_benchmarking) nStart();
    
    var url_hash = hex_sha1(uri);
    
    //check cache
    if ($.cacheCheck(url_hash)) {
       // pull from cache
       try{
           var xdata = $.cacheGet(url_hash);
           var values = decodeReturnArray(xdata); 
           renderChanges(values);
       }
       catch(e){alert(e.message +"  \n 'used cache'\n "+e.description +"\n " +uri+"\n aaaaaaaaaa");}
    }
    else {
        // pull from server
        $.get(uri, function(data){ 
             try{
               var values = decodeReturnArray(data);  
               $.cachePut(url_hash,data); 
             }
             catch(e){alert(e.message +"\n "+e.description +"\n " +uri+"\n aaaaaaaaaa");}
             renderChanges(values);
             
          } );
    }
}

function renderChanges(values)
{
  if (values != undefined){    
     $("#adev-results-content").fadeOut("fast",
         function (){
           $("#adev-results-content").html(decodeSEMANTIC_SEARCHHtml(values[0]));
           $(".hiddenSearchResults").hide();
           $("#adev-results-content").fadeIn("slow");  
         });
         
         $("#reg-search-box").fadeOut("fast",
         function (){
           $("#reg-search-box").html(decodeSEMANTIC_SEARCHHtml(values[1]));
           $("#reg-search-box").fadeIn("slow");  
         });
         
         $("#dev-studies").fadeOut("fast",
             function (){
               $("#ActiveProgress").remove();
               $("#dev-studies").html(decodeSEMANTIC_SEARCHHtml(values[2]));
               $("#dev-studies").fadeIn("slow", function (){
                   //bind
                   bindToggleHelpText();
                   $(".hiddenSearchResults").hide();
                   $.hookExecute('semantic_searchSearchSuccessfulHook'); 
                   
               });  
               
               $("#search-results-title").html(decodeSEMANTIC_SEARCHHtml( values[4] ) );
               if (values[0] != '') {
                  $("#search-results-title-b").html(decodeSEMANTIC_SEARCHHtml( values[4] ) );
               }
               else {
                  $("#search-results-title-b").html('');
               }
                               
               semantic_search_updating = false;
               if (semantic_search_snap) window.reloadSnap();
               snapped = false;
               setLinks();
               
               if (semantic_search_benchmarking) nEnd('roundtrip');
              
               
             }
         );
     }
}

/***/
function semantic_searchToggle(id){
    $("#"+id).slideToggle("slow");
}

/**
 *  when js changes occur on the page
 *  this function refreshes SNAP
 */

function reloadSnap(){
   if (window.snap_preview_anywhere == undefined){
    window.snap_preview_anywhere=new snapPreviewAnywhere();   
   }  
   
   if(window.snap_preview_anywhere != undefined){
        if ($.browser.msie){
            $("a").hover(function(){
                try{
                    if (!snapped) window.snap_preview_anywhere.add_link_events();
               } catch(e){ }
            }, function(){}); 
        }
            
        try{
          window.snap_preview_anywhere.add_link_events();
        } catch(e){ }
       
   }
}



/**
 * a function call to embed in links so that or onChange,
 * the links or selects can submit a search form.
 */
function semantic_searchSearchSubmitSelect(id,prefix) {
   if (url_prefix != null){
       var turl = url_prefix;
   }
   else{
       var turl = default_url_prefix+'?edit[sesu]=1&edit[1980]=1';
   }
   var furi =  turl+'&'+ $('#'+id).attr('name') +'='+ $('#'+id).val();
   semantic_searchSearchSubmitLink(furi);
}

function semantic_searchSearchSubmitButton(){
    //var furi =  uri+ $('#semantic_search-search-fulltext').attr('name') +'='+ $('#semantic_search-search-fulltext').val();
    semantic_searchSearchSubmitLink(_semantic_searchSearchURIBuilder());
}

 /**
  * display an error
  */
 function _semantic_search_err(e,msg){
 	 alert(msg+' ' +e.message );
 }



// TODO chancge to use jquery.form.js
function _semantic_searchFormIterator(type){
    var turl = '';
    $(type,document._SEMANTIC_SEARCHSearch).each(
       function(i){
           switch(this.type){
              case 'text':
                if ($(this).val() != ''){
                   turl += _semantic_searchURLAppend($(this).attr("name"),$(this).val())
                }
                
                break;
              case 'select-one':
                if ($(this).val() != 0){
                   turl += _semantic_searchURLAppend($(this).attr("name"),$(this).val());
                }
                
                break;
           }
       }
   );
   return turl;
}

function _semantic_searchURLAppend(element_name,element_value){
     return sep+element_name+'='+SEMANTIC_SEARCHUrl.encode(element_value);
}

/**
 * @TODO remove
 * all because I don't know how, after a .post to reset the pages functions
 */
function setUrlPrefix(pf) {
    url_prefix = pf;
}

/**
 *  Two purposes
 *   build query string
 *   update form itself
 *  
 *  @return the query string for a SEMANTIC_SEARCH search
 * 
 */
function _semantic_searchSearchURIBuilder(){
    
   //Sadly, These signals come from sonia.const.inc and will break if changed
   //see also var sep= '&';
   if (url_prefix != null){
       var turl = url_prefix;
   }
   else{
       var turl = default_url_prefix+'?edit[sesu]=1&edit[1980]=1';
   }
   var theElement = '';
   var element_type = '';
    
   //TODO select-multiple radio, textarea
   turl += _semantic_searchFormIterator("select");
   turl += _semantic_searchFormIterator("input");
   turl += _semantic_searchFormIterator("checkbox");
   //turl += _semantic_searchFormIterator("textarea");
   return turl;
    	
}

/**
 * work around for back button navigation issue
 */
function setSEMANTIC_SEARCHHistory(semantic_search_rpc_url){
    //needs to pause the SEMANTIC_SEARCHTestURL
    try{
        var temploc = new String(document.location);
        var temparray = temploc.split('#');
        var hash = new String(window.SEMANTIC_SEARCHHistory.length);
        if (semantic_search_rpc_url != null) window.SEMANTIC_SEARCHHistory[hash] = semantic_search_rpc_url;
        else if (semantic_search_rpc_url == null)  window.SEMANTIC_SEARCHHistory[hash] = temploc;
		$.historyLoad(hash);
        
    } catch(e){if(semantic_search_debugging) alert(e + '\n setSEMANTIC_SEARCHHistory()');}
}

function SEMANTIC_SEARCHTestURL(newLocation){
    if (newLocation != '' && window.SEMANTIC_SEARCHHistory != undefined)
    {
        try{
            //now get link from storage
            var newlink = window.SEMANTIC_SEARCHHistory[newLocation];
            if (newlink != undefined && !semantic_search_updating && newlink != rpc_uri){
               if (newLocation != 0) semantic_searchSearchSubmitLink(newlink,false);
               else window.location = newlink;
            }
        }catch(e){ if(semantic_search_debugging) alert(e +'/n @ SEMANTIC_SEARCHTestURL');}
    }
}

function bindToggleHelpText(){
   // $("#NinaSearchNavHelp").show('slow');
    $("#NinaSearchNavHelpTitle").bind("click",function(){
        $("#NinaSearchNavHelp").toggle();
    });
}
