/*
 * Copyright (C) May 2007 Jonathan Hendler
 * The authors can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */
/*
 * #semantic-search-browser-classes, 
#semantic-search-browser-objects, 
#semantic-search-browser-values,
#semantic-search-browser-properties 
 *  { height: 'toggle', opacity: 'toggle'
}
 */

//constants
var sem_browser_padding = 20;
var sem_browser_left_offset = 0;


function sem_browser_reposition(current_focus){
    $('.semantic-search-browser-nav-title').css('border','none');
   $('.search-focus').css('border-bottom','1px solid black');
    
    if (current_focus != '.search-focus') {
        $(current_focus).fadeTo('slow',.5, function(){
             $(current_focus + '> span').slideUp( 'slow'  );
             $('.search-focus').fadeTo('slow',1, function(){});
             
        });
    } else {
        $('.search-focus').fadeTo('slow',1, function(){});
    }
    
    var given_top =  parseInt($(current_focus).css('top'));
    var given_left = sem_browser_left_offset;
    //alert($('.search-focus').height());
    var added_top =  $('.search-focus').height() +sem_browser_padding +  given_top;
    var added_left =  given_left +sem_browser_padding +  $(current_focus).width(); 
    var focus_left =  given_left +sem_browser_padding +  $(current_focus).width()/2; 
    
    
    var left_height = (2*sem_browser_padding) + $('.search-focus').height() +  $('.bottom-left').height();
    var right_height = (2*sem_browser_padding) +  $('.search-focus').height() +  $('.bottom-right').height();
        
    //calculate container height
    var max_height = (left_height<=right_height) ? left_height: right_height;
   
    
    $('#semantic-search-browser-container').animate( { height: max_height }, 'slow', function(){
        $('#semantic-search-browser-triangle').animate({
        top: (added_top -(sem_browser_padding*2)), left: focus_left
        }, 'slow');
        
        $('#semantic-search-browser-jellybean').animate({left: (added_left*2)});
        
        $('.bottom-left').animate({
        top: added_top, left: given_left
        }, 'slow');
        
        $('.bottom-right').animate({
            left: added_left, top: added_top
        }, 'slow');
        
        $('.search-focus').animate({
            top: given_top, left: focus_left
        }, 'slow', function(){
            $('.search-focus > .semantic-search-browser-nav-title').css('border-bottom','1px solid white');
            $('.search-focus ').css('border-bottom','3px solid #444444');
         });
    });
        
   
    
}

$(document).ready(function(){
    
    $('#semantic-search-browser-indicator').css('display','none');
     
    $('.semantic-search-browser-nav-title').click(  function(){
        sem_browser_change_focus(this);
         sem_browser_update_history();
      }
    );
    
     
    
     $('.sidebar').slideToggle('slow',function(){
        $.historyInit(sem_browse_history);
        if (window.SEMANTIC_SEARCHBHistory == undefined) window.SEMANTIC_SEARCHBHistory = new Array();
         
        
        //set classes
        $('#semantic-search-browser-classes').addClass('search-focus');
        $('#semantic-search-browser-properties').addClass('bottom-left');
        $('#semantic-search-browser-values').addClass('bottom-right');
        
        // get data
        sem_browser_refresh_data('.search-focus', function(){
            sem_browser_left_offset = parseInt($('#semantic-search-browser-values').css('left'));
            $('#semantic-search-browser-properties >span').slideUp(  );
            
            $('#semantic-search-browser-values >span').slideUp('slow',function(){
                 sem_browser_update_history();
                 sem_browser_reposition('.search-focus');
            } );
        } , 'CLASSES');
     });
    
    
     
});

function sem_search_browse_generate_search_url(){
    var q_string = '&edit[sesu]=1&edit[1980]=1';
    $('#semantic-search-browser-jellybean > ul li').each( function(i) {
        
        if ($(this).attr('type') == 'PROPERTY_VALUES'){
            q_string += '&edit[p_value][][' + $(this).attr('vv') + ']=' + $(this).attr('title');
        } else if ($(this).attr('type') == 'CLASSES'){
            q_string += '&edit[cat][]['+$(this).attr('title')+']='+$(this).attr('title');
        }
         else  {
            q_string += '&edit[facet][][]='+$(this).attr('title');
        }
    } );
    
    return q_string;
}

//';
function _semantic_searchURLAppend(element_name,element_value){
     return sep+element_name+'='+SEMANTIC_SEARCHUrl.encode(element_value);
}

/**
 * work around for back button navigation issue
 */
function sem_browser_update_history(semantic_search_rpc_url){
    //needs to pause the SEMANTIC_SEARCHTestURL
      
    try{
        var temploc = new String(document.location);
        var temparray = temploc.split('#');
        
        var hash = new String(window.SEMANTIC_SEARCHBHistory.length);
        
        if (semantic_search_rpc_url != null) window.SEMANTIC_SEARCHBHistory[hash] = semantic_search_rpc_url;
        else if (semantic_search_rpc_url == null)  window.SEMANTIC_SEARCHBHistory[hash] = temploc;
		$.historyLoad(hash);
        
    } catch(e){if(true) alert(e + '\n setSEMANTIC_SEARCHBHistory()');}
}

function sem_browse_history(newLocation){
     
    if (newLocation != '' && window.SEMANTIC_SEARCHBHistory != undefined)
    {
        try{
            //now get link from storage
            var newlink = window.SEMANTIC_SEARCHBHistory[newLocation];
            if (newlink != undefined && !false && newlink != SemanticSearchBrowseBaseURL){
                 if (newLocation != 0) var x = 2; //sem_browser_update_history(newlink);
                  else window.location = newlink;
               // alert ( newlink +' '+newLocation);
            }
        }catch(e){ if(true) alert(e +'/n @ SEMANTIC_SEARCHTestURL');}
    }
}


function sem_browser_get_data_type(this_id){
    switch(this_id){
        case 'semantic-search-browser-values':
          return 'PROPERTY_VALUES';
          break;
        case 'semantic-search-browser-properties':
          return 'PROPERTIES';
          break;
        case 'semantic-search-browser-classes':
        default:
          return 'CLASSES';
    }
}

function sem_browser_change_focus(a){
    var this_id = $(a).parent().attr('id');
    var this_class = $(a).parent().attr('class');
    var id_current_focus_id = $('.search-focus').attr('id');
    var data_type = sem_browser_get_data_type(this_id); 
    
    if (this_id != id_current_focus_id) {
        sem_browser_refresh_data('#'+this_id, function(){
            //swap around .search-focus with new focus
            $('#'+id_current_focus_id).removeClass('search-focus');
            $('#'+id_current_focus_id).addClass(this_class);
            $('#'+this_id).addClass('search-focus');
            $('#'+this_id).removeClass(this_class);
             $('.search-focus > span').slideDown('slow',function(){
                 sem_browser_reposition('#'+id_current_focus_id);
             });
        }, data_type);
        
        //refresh heights again
    }
}

function sem_browser_refresh_data(the_id, the_function, data_type){
    var i = 0;
    var uri = '';
    var title = '';
    var base_url = SEMANTIC_SEARCH_BROWSE_RPC_PATH;
    
    $('#semantic-search-browser-indicator').fadeIn();
   
    var search_url = base_url+'?dt='+data_type +  sem_search_browse_generate_search_url();
    $.get(search_url, function(data){ 
         try{
           var values = eval(data);  
           //$.cachePut(url_hash,data); 
         }
         catch(e){alert(e.message +"\n "+e.description +"\n " +search_url+"\n");}
        
        $(the_id+' ul').html('');
            
        for(i=0;i<values[1].length;i++){
            sem_browser_add_item_to_list(the_id,values[1][i].uri,values[1][i].title,values[1][i].type, values[1][i].value);
        }
        
        the_function();
        sem_browser_update_title_counts(values[0]);
        $('#semantic-search-browser-objects>span').html( values[3]+values[2]  );
        $('#semantic-search-browser-indicator').fadeOut(); 
    });
    
}

function sem_browser_update_title_counts(values){
    
     $('#semantic-search-title-count-classes').hover(
    function(){
       $('#semantic-search-title-count-classes').html(
           '<span>' + 
            values.CLASSES.list_total + ' facets<br/>' +
            values.CLASSES.data_total + ' items<br/>' +
            values.CLASSES.in_search_total + ' items in search</span>'
       ); 
        
    },function(){
       $('#semantic-search-title-count-classes').html(' ');
    });
     
     $('#semantic-search-title-count-properties').hover(
    function(){
       $('#semantic-search-title-count-properties').html(
           '<span>' + 
            values.PROPERTIES.list_total + ' facets<br/>' +
            values.PROPERTIES.data_total + ' items<br/>' +
            values.PROPERTIES.in_search_total + ' items in search</span>'
       ); 
        
    },function(){
       $('#semantic-search-title-count-properties').html(' ');
    });
    
    //over, out
    $('#semantic-search-title-count-values').hover(
    function(){
       $('#semantic-search-title-count-values').html(
           '<span>' + 
            values.PROPERTY_VALUES.list_total + ' facets<br/>' +
            values.PROPERTY_VALUES.data_total + ' items<br/>' +
            values.PROPERTY_VALUES.in_search_total + ' items in search</span>'
       ); 
        
    },function(){
       $('#semantic-search-title-count-values').html(' ');
    });
    
}

function sem_browser_add_jellybean(uri,title,type,vv){
   var   n = new Date();
   var id =  'sb-' + n.getTime();
   var new_html = '<li class="jellybean-li" id="'+id+'" title="'+uri+'" type="'+type+'" vv="'+vv+'" ><span class="jellybean-remove" title="remove jellybean" >[-]</span>&nbsp;'+title+'</li>';
   $('#semantic-search-browser-jellybean ul').html(new_html+$('#semantic-search-browser-jellybean ul').html());
   
   sem_browser_refresh_data('.search-focus', function(){
       //overwrite onclick
       $('.jellybean-remove').click(function(){ 
         var ttype = $(this).parent().attr('type');
         $(this).parent().remove(); 
         sem_browser_refresh_data('.search-focus', function(){},ttype );
         });
   }, type);
}

 

function sem_browser_add_item_to_list(container_id,uri,title,type,value){
   var n = new Date();
   var id =  'uri-' + n.getTime();
   var new_html = '<li class="facet-li" id="'+id+'" title="'+uri+'" type="'+type+'" vv="'+value+'" ><span class="facet-add" title="add to search" >[+]</span><span class="facet-title" >&nbsp;'+title+'</span></li>';
   $(container_id+' ul').html(new_html+$(container_id+' ul').html());
   
   $('.facet-add').click(function(){  
      var tid = $(this).parent().attr('id');
      var turi = $(this).parent().attr('title');
      var ttype = $(this).parent().attr('type');
      var vv = $(this).parent().attr('vv');
      var ttitle = $(this).parent().children('.facet-title').html(); 
      sem_browser_add_jellybean(turi,ttitle,ttype,vv); 
    });
}

