<?php
/*
 * Copyright (C) 2006,2007 Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The author can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */
 
 /**
  * These functions, along with theming functions, are all that is required to 
  * build a custom module running on top of Semantic Search
  * */

/**
 * 
 * @param array form
 * @param string action
 * @param boolean cache_stats_only
 * 
 * @return string the html of a search form
 * 
 * @todo handling of fieldsets
 * */
function semantic_search_form_api(& $form, $action = null, $cache_stats_only = false) {
  global $_semantic_search_search;
  if (empty ($_semantic_search_search))
    _SEMANTIC_SEARCH_INIT();
  
  if ($action !== null) $form['#action'] = $action;
  
  //look for items which need parsing
  if(is_array($form)){
    foreach($form as $key=>$element){
    	if (is_array($element) && !empty($element['uris'])){
        $form[$key] = $_semantic_search_search->getSearchFormElement($element);
    	}
    }
  } else {
  	return;
  }
  
  
  if ($cache_stats_only){
    $html =  _semantic_search_cacheStatsFromForm($form);
  } else {
    $html =  _semantic_search_form_render($form);
  }
  
  return $html;
}

/**
 * 
 * */
function semantic_search_search_results_api($vars) {

}



?>