<?php
/*
 * Copyright (C) 2006,2007 Jonathan Hendler
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 * 
 * The author can be contacted at: 
 *  - [hendlerman (at) yahoo DOT com]
 * 
 * @license GPLv2
 * @link    http://drupal.org/project/semantic_search
 */
 
/**
 * detect location
 * */
define('SEMANTIC_SEARCH_LOCATION',dirname(__FILE__).'/');

/**
 * config settings
 * */
require 'semantic_search.conf.inc';

/**
 * constants which should not need to be changed
*/
require SEMANTIC_SEARCH_LOCATION . 'conf/semantic_search.constants.inc';

define('SONIA_LOCATION',SEMANTIC_SEARCH_LOCATION.'contrib/SONIA/');

/**
 * include sonia 
 * */
require SONIA_LOCATION .'sonia.defaults.inc';
require SONIA_LOCATION .'sonia.const.inc';
require SONIA_LOCATION .'sonia.includes.inc';
require SONIA_LOCATION .'sonia.php';

/**
 * automated search form generation
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.searches.inc';
 
/**
 * localized language file
 * 
 * @todo should be handled via drupal
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.lang.inc';

/**
 * search and related functions (a class)
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.search.inc';

/**
 * functions to construct elements of navigation of searches
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.search.navigation.inc';

/**
 * functions to theme the navigation of searches
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.themes.inc';

/**
* static and helper functions
* */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.helpers.inc';

/**
* helper functions relating to forms
* */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.forms.inc';

/**
* helper functions relating javascript and css
* */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.js.inc';

/**
 * adminstrative functionality
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.admin.inc';

/**
 * drupal hooks
 * */
require SEMANTIC_SEARCH_INCLUDE_LOCATION . 'semantic_search.node_hooks.inc';

/**
 * the developer API
 * */
require 'semantic_search.api.inc';
