<?php

/**
 * This test is against arc to verify that a field can be updated (incremented)
 * @package SONIA
 * 
 * */

 define('ARC_LOCATION','/var/biz/sonia_civic/trunk/contrib/arc/');
 define('ARC_DB_PREFIX_NAME','semantic_search');
 define ('ARC_DEFAULT_NS_PREFIX', 'semantic_search');
 define ('ARC_DEFAULT_PREFIXES',
                'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
                PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
                PREFIX owl: <http://www.w3.org/2002/07/owl#>
                PREFIX foaf: <http://xmlns.com/foaf/0.1/> ');
 
  $rdf   = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
  $rdfs  = "http://www.w3.org/2000/01/rdf-schema#";
  $owl   = "http://www.w3.org/2002/07/owl#";
  $dc   ="http://purl.org/dc/elements/1.1/";
  
  define('SONIA_DEFAULT_MODEL_PREFIX','sonia_test');
  define('SONIA_DEFAULT_MODEL_IRI','http://fsearch.org/ns/'.SONIA_DEFAULT_MODEL_PREFIX.'');
  define('SONIA_SPECIAL_SUBJECT','http://arc.web-semantics.org/');
  define('SONIA_SPECIAL_PREDICATE',SONIA_DEFAULT_MODEL_IRI.'#count');
  
 $config = array(
  /* db */
  "db_host"=>"localhost",
  "db_name"=>"arc_test",
  "db_user"=>"root",
  "db_pwd"=>"",
  "prefix"=> ARC_DB_PREFIX_NAME,
  /* store */
  "store_type"=>"basic",
  "id_type"=>"hash_int",
  "reversible_consolidation"=>false,
  "encode_values"=>false,
  "index_type"=>"advanced",
  "index_graph_iris"=>true,
  "index_words"=>true,
  "charset"=>"utf8",
  "prefixes"=>array(
      "rdf"=>   $rdf,
      "rdfs"=>  $rdfs,
      "owl"=>   $owl,
      "dc"=>    $dc,
      "dct"=>"http://purl.org/dc/terms/",
      "foaf"=>"http://xmlns.com/foaf/0.1/"
    )
);
 
 
$api_args = array(
  "inc_path"=>ARC_LOCATION,
  "config"=>$config
);

include(ARC_LOCATION."ARC_api.php");
$api = new ARC_api($api_args);
$api->db_connect();

if (!$api->store_exists()) $success=$api->create_store();

echo (isset($success)) ? 'created store' : 'store not created: it exists ';
echo '<br />';


 
$args = array(
  "result_type"=>"array", // (plain|array|json|xml)
  "graph_iri"=>SONIA_DEFAULT_MODEL_IRI, // required
  "add_triple"=>'<'.SONIA_SPECIAL_SUBJECT.'> <'.SONIA_SPECIAL_PREDICATE.'> "1" .' 
);
 
$tmp =$api->add_data($args);

print_r($tmp);

// now update the data
$args =   array();
$args['result_type'] = 'array';
$args['del_s'] = SONIA_SPECIAL_SUBJECT;
$args['del_p'] = SONIA_SPECIAL_PREDICATE;
$args['add_triple'] = '<'.SONIA_SPECIAL_SUBJECT.'> <'.SONIA_SPECIAL_PREDICATE.'>  "11" .';
$args['graph_iri']  = SONIA_DEFAULT_MODEL_IRI;
$result = $api->update_data($args);

print_r($result);

$query = ARC_DEFAULT_PREFIXES;
      //get if exists
      $query .= 'SELECT ?s  
                WHERE {
                  <'.SONIA_SPECIAL_SUBJECT.'> <'.SONIA_SPECIAL_PREDICATE.'> ?s .
                }';
       //echo nl2br(htmlentities($query)).'<br>';      
       $qr1             = $api->query(array("query"=>$query, "result_type"=>"rows"));
       $rows            = $qr1["result"];
       $row_count       = $qr1["row_count"];
       $temp_facet_hiercharchy     = array(); 
       $answer = $rows[0]['s'];
       echo "\$answer $answer<hr>";
       print_r($qr1);
       $answer = $answer +10;

       

// now update the data
$args =   array();
$args['result_type'] = 'array';
$args['del_s'] = SONIA_SPECIAL_SUBJECT;
$args['del_p'] = SONIA_SPECIAL_PREDICATE;
$args['add_triple'] = '<'.SONIA_SPECIAL_SUBJECT.'> <'.SONIA_SPECIAL_PREDICATE.'>  "'.$answer.'" .';
$args['graph_iri']  = SONIA_DEFAULT_MODEL_IRI;
$result = $api->update_data($args);

print_r($result);

$query = ARC_DEFAULT_PREFIXES;
      //get if exists
      $query .= 'SELECT ?s  
                WHERE {
                  <'.SONIA_SPECIAL_SUBJECT.'> <'.SONIA_SPECIAL_PREDICATE.'> ?s .
                }';
       //echo nl2br(htmlentities($query)).'<br>';      
       $qr1             = $api->query(array("query"=>$query, "result_type"=>"rows"));
       $rows            = $qr1["result"];
       $row_count       = $qr1["row_count"];
       $temp_facet_hiercharchy     = array(); 
       $answer = $rows[0]['s'];
       echo "\$answer $answer<hr>";
       print_r($qr1);
       $answer = $answer +10;


//$success=$api->delete_store();
//$success=$api->reset_store();

 

?>