<?php
//DEFINES
define('SONIA_TEST_NUMBER_OF_CLASSESS','100');
//number of objects
define('SONIA_TEST_NUMBER_OF_OBJECTS','222');

define('SONIA_TEST_NAME','Laptop Medium 2');     
     
/**
 * A script to be called directly which runs through the loading and running
 * of a few basic SONIA tests.
 * 
 * Cache functions are not yet tested as that requires Drupal, and these tests deal
 * less with performant issues than basic functionality
 * 
 * @license GPLv2 
 * @license 2006 KBCMS LLC
 * @author  Jonathan Hendler
 * @package SONIA
 * @version 0.31
 * */
class ST
{
  /**
   * total number of tests to be run
   * */
   public $test_count;
   
   /**
    * cleanup the database when finished
    * */
   public $do_cleanup;
   
   /**
    * */
   public $start_time;
   
   /***/
   public $end_time;
   
   
   /**
    * 
    * */
   public $total_success;
   
  /**
   * why have the functionality outsisw the builtin function?
   * so it can be tested outside the builtin function
   * */
  function __construct($do_cleanup = true)
  {
    $this->init();
    $this->do_cleanup = $do_cleanup;
    $this->base_uri = 'http://mydrupalsite.com/node/';
    $this->total_success = true;
   
  }
  
  function endAll()
  {
    global $max_memory_usage;
    $memory = "Max Memory used: $max_memory_usage";
    $total_time = $this->end_time - $this->start_time;
    $sub     = 'End of tests.';
    $content = 'Note: The get_memory_usage is emulated on some machines. On a P4HT 2.8 Ghz this was a 1 second delay.';
    
    $title = 'end';
//    $this->all_test_results[$title]['time']     = $total_time;
//    $this->all_test_results[$title]['subtitle'] = $sub;
//    $this->all_test_results[$title]['comments'] = $content;
//    $this->all_test_results[$title]['memory']   = $max_memory_usage;
//    $this->all_test_results[$title]['success']  = $this->total_success;
    //output all results
    sonia_test_output_results($this->all_test_results);
    printTestName("Time Elapsed: $total_time seconds. &nbsp;&nbsp;$memory", $content);
  }
  
  function __destruct()
  {
    
    if($this->do_cleanup) $this->testcleanup();
    
  }
  
  function runtests( )
  {
     global $tests;
     
     //variables
     
     //number of classes
     $nc = SONIA_TEST_NUMBER_OF_CLASSESS;
     //number of objects
     $no = SONIA_TEST_NUMBER_OF_OBJECTS;
     
     $this->start_time = this_microtime();
     $this->start_create_class_time = this_microtime();
     
     //create classes
     $this->create_classes($nc);
     //create hierarchy
     $this->create_superclasses($nc);
     //
     $this->class_properties($nc);
     $this->create_objects($no,$nc);
     
     $this->search_classes($no,$nc);
     $this->start_end_class_time = this_microtime();
     
     $this->end_time = this_microtime();
     //log results
     
     $this->endAll();
  }
  
  
  //Load SONIA
  

  
  /**
   * create a class which needs an ID
   * then create a class which does not need an id
   * 
   * */
  function create_classes($nc)
  {
    $success = false;
    $content = '';
    
    $this->createClassesAutoID($nc);
    $this->createClassesWithID($nc);
  
  }
  
  function create_superclasses($nc)
  {
    $content = 'All Passed';
    $success = false;
    $base_uri = 'http://mydrupalsite.com/node/';
    $this->test_start();
     for($i = 0; $i<$nc;$i++)
     {
        if ($i >0)
        {
          $regulator =  ($i>7)? ($i%5): 1;
          $uri1 = $base_uri.$i;
          $uri2 = $base_uri.($i-1);
         // if ($uri1 == $uri2) print "<br />$uri1 == $uri2";
          $this->sonia->store->setSubclass($uri1,$uri2);
        }
     }
     
     $get_id = $nc - ($nc /10) - ($nc /10);
     $superclasses = $this->sonia->store->getAllCategoriesRecursive($base_uri.$get_id,0,'START LABEL');
     
     $depth =  ArrayDepth($superclasses);
     $success = (($depth) == ((3*($nc-$get_id))-1));
     if (!$success)
     { 
       $content = "((3*($nc-$get_id))-1) == $depth " ;
       $this->total_success = false;
     }
     
     //now check to see that they are there
     $this->test_end('Created Subclass Relationships', 'Subclasses set in groups', $content,$success);
     //printTest('Set Subclases in '.$total.' seconds ', 'Set ID based Classes as subclasses of eachother, tested this was true',$content,$success);
   }
  
  function delete_subclasses()
  {
    $content = 'All Passed';
    $success = false;
    $base_uri = 'http://mydrupalsite.com/node/';
    $superclasses = $this->sonia->store->getAllCategoriesRecursive( );
    dbg($superclasses,'$superclasses?');
    $this->sonia->deleteClass($base_uri.'4');
    $superclasses = $this->sonia->store->getAllCategoriesRecursive($base_uri.'0',0,true);
    
     $depth =  ArrayDepth($superclasses);
     $success = ($depth == 6);
     if (!$success)
     { 
       $content = 'should be 6  $depth ='.$depth;
       dbg($superclasses,'$superclasses?');
       $this->total_success = false;
     }
     
    printTest('Deleted Subclases ', 'Deleted Subclasses from ID 4 and below, tested this was true',$content,$success);
  }
  
  /**
   * update the labels , add and alter descriptions
   * add and alter tags 
   * **/
  function update_classes()
  {
    $content = 'All Passed';
    $success = true;
    $base_uri = 'http://mydrupalsite.com/node/';
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
    
    $label_1_before = $this->sonia->getLabel($class_one);
    if ($label_1_before != $original_class_label.' 0')
    {
      $success = false;
      $content = "$label_1_before != $original_class_label";
    }
    
    $label_2_before = $this->sonia->getLabel($class_two);
    if ($label_2_before != $original_class_label.' 1') 
    {
      $success = false;
      $content = "$label_2_before != $original_class_label";
    }
    
    $new_label_1 = "Second Class Name"; 
    $new_label_2 = "Second Class Name Updated too"; 
    
    $this->sonia->updateClass($class_one,$new_label_1);
    $this->sonia->updateClass($class_two,$new_label_2);
    
    
    $label_1_after = $this->sonia->getLabel($class_one);
    $label_2_after = $this->sonia->getLabel($class_two);
    
    if ($label_1_after != $new_label_1) 
    {
      $success = false;
      $content = "$label_1_after != $new_label_1";
    }
    
    if ($label_2_after != $new_label_2) 
    {
      $success = false;
      $content = "$label_2_after != $new_label_2";
    }
    
    $class_1_description = 'Very Very very nice. 150897 haf9upq84797-8q4-75camp(*^$^80  afa sdf af';
    
    //add comment
    $this->sonia->createComment($class_one,$class_1_description);
    
    //check comment
    $rdescription =  $this->sonia->getComment($class_one);
    
    if ($class_1_description != $rdescription) 
    {
      $success = false;
      $content = "$class_1_description != $rdescription";
    }
    
    $class_1_description = $class_1_description .' UPDATED';
    //update comment
    
    $this->sonia->updateComment($class_one,$class_1_description);
    //temp
    $this->sonia->createComment($class_one,$class_1_description);
    $rdescription =  $this->sonia->getComment($class_one);
    
    if ($class_1_description != $rdescription) 
    {
      $success = false;
      $content = " UPDATE FAILED: $class_1_description != $rdescription";
    }
    //delete comment    
    
    $this->sonia->deleteComment($class_one);
    
    $rdescription =  $this->sonia->getComment($class_one);
    
    if ('' != $rdescription) 
    {
      $success = false;
      $content = " Delete FAILED: null != $rdescription";
    }
    
    if (!$success)
     { 
       $this->total_success = false;
     }
    
    printTest('Updated classes ', 
      'Retrieved two classes Labels.  Updated two classes labels. Retrieved and tested these and comments.',$content,$success);
  }
  
  function class_properties($nc)
  {
    $content = 'All Passed';
    $success = true;
    $base_uri = $this->base_uri;
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
    $class_three = $base_uri.'3';
    $count = 0;
    $this->test_start();
    $property_label_one = ' First Clss for properties';
    $property_label_two = ' Second Clss for properties';
    //$this->base_uri
    $class_array_one = array($class_one,$class_two);
    $class_array_two = array($class_one);
    
    $property1 = $this->sonia->createProperty($property_label_one,$class_array_one );
    $property2 = $this->sonia->createProperty($property_label_two, $class_array_two);
    
    if (!$this->sonia->propertyExists($property2))
    { 
      $success = false;
      $content = "$property2 should exist!!";
    }
    //echo "<br> \$property1 $property1 \$property2 $property2 <br/>";
    
    $this->sonia->addPropertyToClass($class_two,$property2);
    
    $class1_properties = $this->sonia->getAllClassProperties($count, $class_one);
    //get all properties of each class
    $class1_properties = $class1_properties['rdfs:domain']['subclasses'];
     
    if (!array_key_exists($property1,$class1_properties) || !array_key_exists($property2,$class1_properties))
    { 
      $success = false;
      $content = "$property1 not found OR $property2 not found in class $class_one ";
    }
    
    $class2_properties = $this->sonia->getAllClassProperties($count, $class_two);
    //get all properties of each class
    $class2_properties = $class2_properties['rdfs:domain']['subclasses'];
     
    if (!array_key_exists($property1,$class2_properties) || !array_key_exists($property2,$class2_properties))
    { 
      $success = false;
      $content = "$property1 not found OR $property2 not found in class $class_two";
    }
    
    //remove property 1 from class 1
    $this->sonia->deletePropertyFromClass($class_one, $property1);
    
    $class1_properties = $this->sonia->getAllClassProperties($count, $class_one);
    //get all properties of each class
    $class1_properties = $class1_properties['rdfs:domain']['subclasses'];
    
    if (array_key_exists($property1,$class1_properties) || !array_key_exists($property2,$class1_properties))
    { 
      $success = false;
      $content = "$property1  *found* (and it should not be) OR $property2 not found. ";
      $content .= array_key_exists($property1,$class1_properties). ' should be false.';
      $content .= !array_key_exists($property2,$class1_properties). ' should be false.';
    }
    
    
    $classes_1 = $this->sonia->store->getAllClassesOfProperty($property1);
    $classes_1 = $classes_1['http://www.w3.org/2000/01/rdf-schema#Class']['subclasses'];
    $classes_2 = $this->sonia->store->getAllClassesOfProperty($property2);
    $classes_2 = $classes_2['http://www.w3.org/2000/01/rdf-schema#Class']['subclasses'];
    
    //get all classes of each property
    //check count
    if (array_key_exists($class_one,$classes_1) || !array_key_exists($class_two,$classes_1))
    { 
      $success = false;
      $content = "$class_one  *found* (and it should not be) OR $class_two not found. ";
    }
    
    if (!array_key_exists($class_one,$classes_2) || !array_key_exists($class_two,$classes_2))
    { 
      $success = false;
      dbg($classes_2,'$classes_2');
      $content = "$class_one  not found OR $class_two not found. 3";
    }
    
    
       
    
    //update label
    $new_label = 'This is the new label for property 1';
    $this->sonia->updateLabel($property1, $new_label);
    //$property_label_one_old = $property_label_one;
    $property_label_one_r = $this->sonia->getLabel($property1);
    //verify change was made
    if ( $property_label_one_r != $new_label )
    { 
      $success = false;
      $content = "label was not updated properly - should be \"$new_label\"";
    }
    
    //delete property entirely 
    $this->sonia->deleteProperty($property1);
    $class2_properties = $this->sonia->getAllClassProperties($count, $class_two);
    //get all properties of each class
    $class2_properties = $class2_properties['rdfs:domain']['subclasses'];
    
    if (array_key_exists($property1,$class2_properties) || !array_key_exists($property2,$class2_properties))
    { 
      $success = false;
      $content = "$property1  *found* (and it should not be) OR $property2 not found. ";
    }

    //create same as class
     if (!$success)
     { 
       $this->total_success = false;
     }
     
      
      //add some more properties for later tests
      for($i=0;$i<10;$i++)
      {
        $p{$i} = $this->sonia->createProperty("Label $i" );
        $this->sonia->addPropertyToClass($class_two,$p{$i});
      }
      
      for($i=0;$i<$nc;$i++)
      {
        $p{$i} = $this->sonia->createProperty("Label $i" );
        $class = $base_uri.$i;
        $this->sonia->addPropertyToClass($class,$p{$i});
      }
      
      $this->sonia->deletePropertyFromClass($class_two, $property2);
      
      $this->sonia->addPropertyToClass($class_one,$p{($i-1)});
      
      $this->test_end('CRUD Class Properities  ', 'Class Properties are added, 
        removed to classes, Searched for and deleted.', $content,$success);
  }//end function
  
  function create_objects($no,$nc)
  {
    $this->test_start();
    $count = 0;
    $content = 'All Passed';
    $success = true;
    $base_uri = $this->base_uri;
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
    $class_three = $base_uri.'2';
    
    $object_one_name = 'OBJECT ONE';
    $object_two_name = 'OBJECT TWO';
    $object_three_name = 'OBJECT THREE';
    $object_four_name = 'OBJECT FOUR';
    
    $classes_one = array($class_one);
    $classes_two = array($class_two,$class_three);
    $classes_three = array($class_one,$class_three);
    
    $class1_properties = $this->sonia->store->getAllClassPropertiesMultiple($count, $classes_one);
    $class2_properties = $this->sonia->store->getAllClassPropertiesMultiple($count, $classes_two);
    $class3_properties = $this->sonia->store->getAllClassPropertiesMultiple($count, $classes_three);
    
    //what does this hack do?
    $class1_properties = $class1_properties['rdfs:domain']['subclasses'];
    $class2_properties = $class2_properties['rdfs:domain']['subclasses'];
    $class3_properties = $class3_properties['rdfs:domain']['subclasses'];
    
    srand(make_seed());
    
    $object_create = ceil($no/$nc);
    $total_created = $object_create * $nc;
    //for each classes
    for($i=0;$i<$nc;$i++)
    {
      $the_class = $base_uri.$i;
      $props = $this->sonia->store->getAllClassPropertiesMultiple($count, $classes_one);
      $props = $props['rdfs:domain']['subclasses'];
      $count = 0;
      $parameters = array();
      
      foreach($props as $property => $label)
      {
        $randval = md5(rand(3,297824897025));
        $parameters[$count]['uri'] = $property;
        $parameters[$count]['value'] = $randval;
        $count++;
        
      }
      
      for ($j =0;$j<=$object_create;$j++)
      {
        $object_name = 'OBJECT NAMED '.$i.':'.$j;
        $object = $this->sonia->createObject(
            $object_name, //TODO not needed?
            $the_class,
            $parameters
        );
      }
    }
    //get all it's properties
    //create an object
    dbg($object,'last $object created');
    
    
     if (!$success)
     { 
       $this->total_success = false;
     }
     
//      printTest('Created Objects - created '.$total_created.' in '.$total.' seconds', 
//      'Objects are created...',$content,$success);
      
     $this->test_end('Created Objects ', 'Objects are created...', $content,$success);
  }
  
  
  
  
  function search_classes($no,$nc)
  {
   
    
    $content = 'All Passed';
    $success = true;
    $base_uri = $this->base_uri;
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
    $class_three = $base_uri.'3';
    
    //get all classes and their labels flat
    //get count of related objects
    //$result = $this->sonia->getAllClassesFlat();
    //$all_classes_count = count($result);
    
    //dbg($result,'$result $all_classes_count= '.$all_classes_count);
   
    $this->test_start();
    $result = $this->sonia->store->getAllCategoriesRecursive(); //this should work
    $all_classes_count = count($all_classes_count);
    if (empty($result) || $all_classes_count != 21)
    { 
      $success = false;
      $content = "getAllCategoriesRecursive() failed \$all_classes_count = $all_classes_count";
      dbg($result,'$result = $this->sonia->getAllCategoriesRecursive();');
    }
    
    $this->test_end('Get All classes recursively as hierarchy', ' getAllCategoriesRecursive() ', "\$all_classes_count = $all_classes_count",$success);   
    
    //test format
    $this->test_start();
    $result = $this->sonia->classQuery(null);
    $all_classes_count = count($result);
    $this->test_end('Get All classes as list', ' one at a time ', "\$all_classes_count = $all_classes_count",$success);
    
    $this->test_start();
    $result = $this->sonia->propertyQuery();
    $all_property_count = count($result);
    $this->test_end('Get All Properties', '  $this->sonia->propertyQuery()', "\$all_property_count = $all_property_count" ,$success);
    //dbg($result,'$result $all_property_count= '.$all_property_count);
    //get all classes and their labels in hiearchy
    //$result = $this->sonia->getAllCategoriesRecursive();
     
    $base_uri = $this->base_uri;
    
    $this->test_start();
    for($i=0;$i<$no;$i++)
    {
      //get 100 objects one at a time
      $object_uri = 'http://soniatest.org/ns/sonia_test/Object#id'.$i;
      $object = $this->sonia->getObject($object_uri);
    }
    
    
    $this->test_end('Get All Objects', ' one at a time ', $object_uri,$success);
    
    //get object labels
    $this->test_start();
    for($i=0;$i<$no;$i++)
    {
      //get 100 objects one at a time
      $object_uri = 'http://soniatest.org/ns/sonia_test/Object#id'.$i;
      $label = $this->sonia->getLabel($object_uri);
    }
    
    
    $this->test_end('Get All Objects Labels Only Sonia layer', ' one at a time ', $label,$success);
    
    $this->test_start();
    for($i=0;$i<$no;$i++)
    {
      //get 100 objects one at a time
      $object_uri = 'http://soniatest.org/ns/sonia_test/Object#id'.$i;
      $label = $this->sonia->store->getLabel($object_uri);
    }
    
    $this->test_end('Get All Objects Labels Only Store Layer', ' one at a time  $this->sonia->store->getLabel($object_uri)', $label,$success);
   
    
    $this->test_start();
    for($i=0;$i<$no;$i++)
    {
      //get 100 objects one at a time
      $object_uri = 'http://soniatest.org/ns/sonia_test/Object#id'.$i;
      $classes = $this->sonia->getAllClassesOfObject($object_uri);
    }
    
    $this->test_end('Get All Classes of an object', 'TODO one at a time getAllClassesOfObject() ', $label,$success);
    
    
     $this->test_start();
    for($i=0;$i<$nc;$i++)
    {
      $sonia_search_array = null;
      
      $class = $base_uri.$i;
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class,
      'literal_object'=>false,
      'category_query'=>false);  
      
      $result = $this->sonia->query(0,$sonia_search_array,null,null,true,'','',true);
    }
    
    $this->test_end('Get All Objects of a class', 'one query per each class full query object', $label,$success);
    
    
    
     $this->test_start();
    for($i=0;$i<$nc;$i++)
    {
      $sonia_search_array = null;
      
      $class = $base_uri.$i;
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class,
      'literal_object'=>false,
      'category_query'=>false); 
      
       $class2 = $base_uri.($i+1);
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class2,
      'literal_object'=>false,
      'category_query'=>false); 
      
      
      $result = $this->sonia->query(0,$sonia_search_array,null,null,true,'','',true);
    }
    
    $this->test_end('Get All Objects of TWO classes', 'one query per each class full query object', $label,$success);
    
    $this->test_start();
    for($i=0;$i<$nc;$i++)
    {
      $sonia_search_array = null;
      
      $class = $base_uri.$i;
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class,
      'literal_object'=>false,
      'category_query'=>false); 
      
       $class2 = $base_uri.($i+1);
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class2,
      'literal_object'=>false,
      'category_query'=>false);
      
       $class3 = $base_uri.($i+21);
      $sonia_search_array[] = array (
      'subject'=>null,
      'predicate'=> SONIA_RDF_CREATE_TYPE,
      'object'=>$class3,
      'literal_object'=>false,
      'category_query'=>false);
      
      $result = $this->sonia->query(0,$sonia_search_array,null,null,true,'','',true);
    }
    
    $this->test_end('Get All Objects of THREE classes', 'one query per each class full query object', $label,$success);
    
    
    ///////////////////////////////////////////////////////////////////////////
    $this->test_start();
    
    $sonia_search_array[] = array (
    'subject'=>null,
    'predicate'=> SONIA_RDFS_CREATE_LABEL,
    'object'=>'OBJECT',
    'literal_object'=>true,
    'category_query'=>false); 
    $result = $this->sonia->query(0,$sonia_search_array,null,null,true,'','',true);
    $this->test_end('Get All Objects using FILTER - should succeed', 'one query ONLY!! one should have success, the other fail', $label,$success);
    
    
    $this->test_start();
    $sonia_search_array[] = array (
    'subject'=>null,
    'predicate'=> SONIA_RDFS_CREATE_LABEL,
    'object'=>'YOU WONT FIND THIS..... ',
    'literal_object'=>true,
    'category_query'=>false); 
    $result = $this->sonia->query(0,$sonia_search_array,null,null,true,'','',true);
    
    $this->test_end('Get All Objects using FILTER - should fail', 'one query ONLY!! one should have success, the other fail', $label,$success);
    
    
    
    //give a class get objects and object labels
    
    //give a class and get properies and labels
    
    
    //give an object and get properties
    
    //give and object and get classes and their labels
    
    
    //give a property label and
    
    
    //give a property ID and get classes which have it
    
    //give a property ID and get objects which have it
    
    
    //get all classes belonging to an object
    
    
    
        $test_query = 
'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX foaf: <http://xmlns.com/foaf/0.1/>
PREFIX semantic_search: <http://sonia.test.net/ns/semantic_search#>
PREFIX sonia: <http://sonia.test.net/ns/sonia#>
PREFIX soniap: <http://fsearch.org/ns/sonia_test/Property#>
PREFIX carsf: <http://semantic_search.test.net/ns/car-spacefinder#>
SELECT  DISTINCT ?s ?p  ?o 
WHERE {
?s ?p ?o .


}';

//?s <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?type .
//?type <http://www.w3.org/2000/01/rdf-schema#label> ?t_label .

//?p <http://www.w3.org/2000/01/rdf-schema#label> ?p_label .
//?s <http://www.w3.org/1999/02/22-rdf-syntax-ns#type> ?type .
//?type <http://www.w3.org/2000/01/rdf-schema#label> ?t_label .

 
 //?p_label ?o ?t_label ?type
// ?p rdfs:label ?p_label .
//?s rdf:type ?type .
//?type rdfs:label ?t_label .
     
     $this->test_start();
     $results = $this->sonia->store->query($test_query, false, false);
     if (!$success)
     { 
       $this->total_success = false;
     }
     
     $this->test_end('Get All statements', '  ', $test_query,$success);
     // print_r($results);
    
//    if (array_key_exists($property1,$class2_properties) || !array_key_exists($property2,$class2_properties))
//    { 
//      $success = false;
//      $content = "$property1  *found* (and it should not be) OR $property2 not found. ";
//    }
        
    //get object, and it's params and labels by $uri
    //get object, and it's params and labels by main label

      
      
     
     //printTest('Search tests complete in '.$total.' seconds', 'Searches classes, objects and properties',$content,$success);
  }
  
  function add_properties_to_superclass()
  {
    $content = 'All Passed';
    $success = true;
    $base_uri = $this->base_uri;
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
  }
  
  function  test_subclass_properties()
  {
    $content = 'All Passed';
    $success = true;
    $base_uri = $this->base_uri;
    $original_class_label = 'My First Class';
    $class_one = $base_uri.'0';
    $class_two = $base_uri.'1';
  }
  
  
  /**
   * create classes with IDs provided, like drupal's Node ID
   * */
   function createClassesWithID($nc)
   {
      $success = false;
      $content = '';
      $class_amount = $nc;
      $this->test_start();
      
      $base_uri = 'http://mydrupalsite.com/node/';
      for($i = 0; $i<$class_amount;$i++)
      {
        $uri = $this->sonia->createClass('My First Class '.$i,null,$base_uri.$i);
      }
      
      $exists = $this->sonia->classExists($uri) ;
      
      //measure success by if the URIs match
      $success = (($base_uri.($i-1) == $uri) && (SONIA_H :: is_IRI($uri)) && $exists);
      if (!$success) $content .= "ERROR: $base_uri".($i-1)." == $uri ?";
      $id1 = SONIA_H :: getIDFromURI($uri);
      
      $class_with_given_id_with_underscore = $base_uri.'funny_name_is';
      $uri = $this->sonia->createClass('My First Class',array(),$class_with_given_id_with_underscore);
      $exists = $this->sonia->classExists($class_with_given_id_with_underscore) ;
      
      if (!$exists)
      { 
        $success = false;
        $content = "ID was $class_with_given_id_with_underscore was not created";
      }
      
      
       if (!$success)
       { 
         $this->total_success = false;
       }
      $this->test_end('Created GivenID classes ', 'An Identifeier is provided', $content,$success);
      // printTest('Creating '.$class_amount.' ID included classes in '.$total.' seconds', 'Provides an ID in the form of a URI ',$content,$success);
      //test to make sure duplicates are not allowed?
   }
  
  /**
   * create classes that require an autoID
   * */
  function createClassesAutoID($nc)
  {
    
    $this->test_start();
    $success = false;
    $content = '';
    $uri1 = $this->sonia->createClass('My First Class',null);
    $id1 = SONIA_H :: getIDFromURI($uri1);
    $content = "created class $uri1 with id <strong>$id1</strong>";
    $success = SONIA_H :: is_IRI($uri1) && ($id1 == SONIA_AUTO_ID_PREFIX.'1') ; 
    if (!$success) $content = "Retrieved id ".$id1." from class $uri1";
    printTest('Creating Standard Class 1', 'Requires the generation of an ID ',$content,$success);
    
    
    //////////////////////////////////////////////////
    //create 10 more
    $created_classes = $nc;
    
    for($i=0;$i<$created_classes;$i++)
    {
      $turi = $this->sonia->createClass('CLASS '.$i,null);
    }
    $tid = SONIA_H :: getIDFromURI($turi);
    $success = SONIA_H :: is_IRI($turi) && ($tid == SONIA_AUTO_ID_PREFIX.($nc+1)) ; 
    $content = "created class $turi with id <strong>$tid</strong>";
    if (!$success) $content = "Retrieved id ".$tid." from class ".SONIA_AUTO_ID_PREFIX.($nc-1);
     if (!$success)
     { 
       $this->total_success = false;
     }
     
    //printTest('Created '.$created_classes.' classes with Genderated IDs in '.$total.' seconds.', 'Requires the generation of an ID ',$content,$success);
    
    $this->test_end('Created AutoID classes ', 'Requires Generation of an id', $content,$success);
    ////////////////////////////////////////////
  }
  
  
  //destroy ARC DB
  
  
  
///////////////////////////////////////////////////////////////////////////////  
  /// these functions shouldn't change
  
  /**
   * bootstrap order is very important :)
   * */
  function init()
  { 
    global $tests;
    
    $this->tests = $tests;
    $this->test_count = count($tests);
    
    printTestName('Starting Sonia Tests', 'Beggining '.$this->test_count.' tests of Sonia.
      <br />PHP Version '. phpversion());
    
    
    require SONIA_LOCATION.'/sonia.php';
    //init sonia 
    
    $this->sonia = new SONIA(
      SONIA_BACKEND_TYPE,
      SONIA_FORM_ARRAY_PREFIX,
      'drupal',
      null,
      null,
      true //create a database
    );
    
    $port = ARC_DB_PORT;
    if (!empty( $port ))
    {
      $port = ':' . $port;
    }
    
    
    $this->dbconn = new SONIA_TEST_MYSQL_DB(ARC_DB_NAME,ARC_DB_PW,ARC_DB_USER,ARC_DB_HOST.$port);
    $sql = 'SELECT * FROM `'.SONIA_DB_PREFIX_NAME.'_id2val`';
    $result = $this->dbconn->get_array($sql);
    $content = 'Passed uneventfully.';
    $success = (!empty($result[0]['id']));
    if (!$success) $content = 'Test may have failed because the tables already exist. Change SONIA_TEST_CLEANUP in your config file';
    printTest('Creating DB', 'Creates an Arc Database',$content,$success);
    
  }
  
    //Create ARC DB
  function create_database()
  {
    if (!class_exists('SONIAARCStore'))
    { 
      set_sonia_configs('sonia_arc_local','drupal'); 
    }
    
    $this->store       = new SONIAARCStore(null);
    //basic check
    $success = $this->store  instanceof SONIAStoreAPI;
    $content = '';
    
    printTest('Creating Store Object', 'Creates a SONIA store object.',$content,$success);

    $content = 'Passed uneventfully.';
    $table_names = $this->store->installBackend('sprintf');
    //print_r($table_names);
    $success = (!empty($table_names))? true  : false;
    
     
  }
  
  
  function test_start()
  {
    $this->test_start_time =  this_microtime();
  }
  
  
  function test_end($title,$sub, $content,$success)
  {
    
    printTest($title,$sub,$content,$success);
    if (!$success) $this->total_success = false;
    
    $memory =   memory_get_usage();
    $time = this_microtime() - $this->test_start_time; 
    $this->all_test_results[$title]['time'] = $time;
    $this->all_test_results[$title]['subtitle'] = $sub;
    $this->all_test_results[$title]['comments'] = $content;
    $this->all_test_results[$title]['memory'] = $memory;
    $this->all_test_results[$title]['success'] = $success; 
  }
  
  /**
   * @param string truncate or drop
   * */
  function testcleanup($action = 'DROP')
  {
     //`".SONIA_DB_PREFIX_NAME."_store_var`, 
     //remove databases
     $content = '';
     $sql = "$action TABLE `".SONIA_DB_PREFIX_NAME."_id2val`, `".SONIA_DB_PREFIX_NAME."_triple`, `".SONIA_DB_PREFIX_NAME."_triple_dup`, `".SONIA_DB_PREFIX_NAME."_triple_all_wdup`;";
     $success = $this->dbconn->query($sql);
     if (!$success)
     { 
       $this->total_success = false;
       $content = print_r($success,1);
       $content .= mysql_error();
     }
     printTest('Database Cleaned', ' The database has removed traces of the test ',$sql,$success);
     printTest('ALL TESTS STATUS', ' The status of all tests',$content, $this->total_success);
  }

} //end class
?>