<?php
//DEFINES
/**
 * configuration file mirring the main apps sonia.conf.inc
 * 
 *  @package SONIA
 * */
  
  define('CONFIG_FILE_LOADED', true);
  
  /**
   * which tests will be run
   * all new tests must be registered here
   * */
  global $tests;
  $tests = array();
  //ORDER MATTERS
  $tests[] = 'create_classes';
  $tests[] = 'create_superclasses';
  $tests[] = 'delete_subclasses';
  $tests[] = 'update_classes';
  $tests[] = 'class_properties';
  $tests[] = 'crud_objects';
  //$tests[] = 'search_classes';
  //$tests[] = 'add_properties_to_superclass';
  //$tests[] = 'test_subclass_properties';
  //$tests[] = '';
  
  //define('SONIA_DEBUG',true);
  /**
   * remove the database and perform other cleanups at the end of the test
   * set to false if you want to see the state of the database at a certain point
   * */
  define('SONIA_TEST_CLEANUP',true); 
  
  define('SONIA_LOCATION','/var/biz/sonia_civic/trunk/');
  
  /**
   * the printing function name for messages
   * */
  define('SONIA_PRINT_MESSAGE_METHOD','sprintf');
  
  /**
   * this file!
   * */
  define('SONIA_CONFIG_FILE',SONIA_LOCATION.'tests/sonia.test.config.php');
  /**
  * Choose how 
  * */
  define('SONIA_BACKEND_TYPE','sonia_arc_local');

  define('APP_DIRECTORY',SONIA_LOCATION.'/');
  
  define('SEMANTIC_SEARCH_CRUD_REQUEST_SIGNAL',20905982);
  define('CACHE_TEMPORARY',1);
  
  
  /////////////////////////////////////////////////////////////////
  
  /***
  * should be "edit" for Drupal
  * change name for semantic_search
  * @todo move out of SONIA into SEMANTIC_SEARCH and depricate
  * */
  define('SONIA_FORM_ARRAY_PREFIX','edit');
  
  //INCLUDES
  //ORDER MATTERS!
  define('SONIA_DEFAULT_MODEL_PREFIX','sonia_test');
  define('SONIA_DEFAULT_MODEL_IRI','http://soniatest.org/ns/'.SONIA_DEFAULT_MODEL_PREFIX.'');
  //Todo Refactor
  define('SONIA_DEBUG', true);
  define('SONIA_ERROR_LOG','/Temp/SONIAERROR.txt');
  
  require APP_DIRECTORY.'conf/sonia.const.inc';
  require APP_DIRECTORY.'conf/sonia.includes.inc';
  
    

  define('SONIA_DEFAULT_TOP_RESOURCE_ID', 0);
  
  /**
   * IN functions that need a starting point with the data, what is the default
   * value for a starting category
   * */
  define('SONIA_DEFAULT_CATEGORY_START_ID', 'rdfs:Class');
  define('SONIA_DEFAULT_FACET_START_ID',2);
 
  
 
/**
 * @package SONIA
 * */
function set_sonia_configs($config, $env='drupal')
{
  switch ($env)
  {
    case 'standalone':
      break;
    case 'drupal':
    default:
      require TOOLS_DIRECTORY.'io/drupal/drupal.io.sonia.php';   
      break;
  }
  
  switch ($config)
  {
    case 'sonia_native_local':
//      // GLOBALS
//      global $db_conn;
//      
//      require TOOLS_DIRECTORY.'db.class.php';
//      require TOOLS_DIRECTORY.'stores/native/sonia.native.store.php';
//      
//      // DEFINES
//      define('SONIA_RUN_INIT_TESTS', true);
//
//      // DATABASE
//      // TODO change these from defines to private member variables
//      define('SONIA_DB', 'sonia');
//      define('SONIA_DB_USER', 'root');
//      define('SONIA_DB_PASSWORD', '');
//      define('SONIA_DB_HOST', '127.0.0.1:3306');
//      define('SONIA_DB_PREFIX_NAME','semantic_search1');
//      
//      define('LITTLE_LITERAL_MAX',510);
//
//      define('SONIA_INSTANCE','InstanceOf');
//      
//      if (!function_exists('xmlTreeMaker'))
//      {
//        require TOOLS_DIRECTORY.'xml2hash.php';
//      }
//      
//      $db_conn = new SONIADB(SONIA_DB,SONIA_DB_PASSWORD,SONIA_DB_USER,SONIA_DB_HOST);

      break;
    case 'sonia_arc_local':
    
      define('SONIA_DB_PREFIX_NAME','semantic_search1');
      define('SONIA_LOCAL_ARC_TOOLS', TOOLS_DIRECTORY.'/stores/arc_local'); 
      define('SONIA_ARC', SONIA_LOCATION.'/contrib/arc'); 
      
      require SONIA_LOCAL_ARC_TOOLS.'/semantic_search_get_arc_config.php';
      require SONIA_ARC.'/ARC_api.php';
      require SONIA_LOCAL_ARC_TOOLS.'/sonia.arc_local.store.php';
      
      define('SONIA_WRITE_ARC_LOG', true);
      define('SONIA_ARC_LOG_PATH', SONIA_LOCAL_ARC_TOOLS.'/logs/');
      
      define('SONIA_RUN_INIT_TESTS', true);
      //some forms, like in drupal add an array to the form request params
      //VERY IMPORTANT
      define('SONIA_FORM_REQUEST_PREFIX','edit');
      
      define('SONIA_COMMENCE_SEARCH','1980');
      
      //for host
      /**
       * datatabase that ARC uses
       * */
      define('ARC_DB_NAME','stest');
      
      /**
       * ARC DB username
       * */
      define('ARC_DB_USER','root');
      
      /**
       * ARC DB password
       * */
      define('ARC_DB_PW','');
      
      /**
       * ARC DB host
       * */
      define('ARC_DB_HOST','localhost');
      
      /**
       * ARC DB port... should be 3306 in most cases
       * */
      define('ARC_DB_PORT',3306);
      
      /**
       * table name prefix to use in case using the same DB which has non - arc tables
       * */
      define('ARC_DB_PREFIX_NAME','semantic_search1');
      
      /**
       * ARC can return multiple ways. Rows refers to a PHP array which 
       * SONIA depends - this should not have to change
       * */
      define('ARC_DEFAULT_RESULT_TYPE','rows');
      
      
      //// MOVE
      define('SONIA_INSTANCE','type');
      
      /**
       * Location of RDF files to import and export
       * */
      define ('ARC_RDF_FILE_LOCATION',APP_DIRECTORY.'/data/');
      
        

      /**
       * URI of the model name. As you collect RDF data you will want
       * to refer to that set of data with a URI... a collection
       * */
      define ('ARC_MAIN_DATA_IRI',SONIA_DEFAULT_MODEL_IRI);
      //if (defined('SONIA_DEFAULT_CATEGORY_START_ID'))
      //define ('SONIA_DEFAULT_CATEGORY_START_ID', 'Space');
      define ('ARC_DEFAULT_NS_PREFIX', 'semantic_search');
      define ('ARC_DEFAULT_PREFIXES',
                'PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
                PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
                PREFIX owl: <http://www.w3.org/2002/07/owl#>
                PREFIX foaf: <http://xmlns.com/foaf/0.1/>
                PREFIX semantic_search: <http://semanticsearch.org/ns/semantic_search#>
                PREFIX sonia: <'.SONIA_BASE_IRI.'#>
                PREFIX soniap: <'.SONIA_PROPERTY_ID_URI.'>
                PREFIX carsf: <http://semanticsearch.org/ns/car-spacefinder#>');
      break;
    default:
      die('Incorrect conifg option in sonia.conf.inc -> '.$config);
  }

} 



?>