<?php
//DEFINES
/**
 * @author Jonathan Hendler
 * @package SONIA
 * */
  
  
//-----
//print test name
/**
 * basic printing for the result of a test
 * */
function printTest($name, $description, $content, $success)
{
  global $max_memory_usage;
  if (function_exists('memory_get_usage')) $current_usage = memory_get_usage();
  if ($current_usage > $max_memory_usage) $max_memory_usage = $current_usage;
  
  if ($success)
  {
    printSuccess();
  }
  else 
  {
    printFail();
  }
  printTestName($name, $description);
  pmsg($content);
  
   flush();
}


function printFail()
{
  print '<div class="testFailed"> FAILED </div>';
  
}

function printSuccess()
{
  print '<div class="testPassed"> SUCCESS </div>';
}

function printTestName($testname, $description)
{
  print '<div class="testname">'.$testname.'</div>';
  print '<div class="test_description">'.$description.'</div>';
   flush();
}

/*print a general message*/
function pmsg($msg)
{
  print '<div class="pmsg">'.$msg.'</div>';
   flush();
}

//------------------------------------------------------
/**
 * requires DBG
 * */
 function doDebugBreak()
 {
  if (function_exists('DebugBreak'))
  {
    DebugBreak();
  }
  else
  {
    trigger_error( 'You must install the debugger "DBG":<br/> see <a href="http://www.plog4u.org/index.php/Using_PHPEclipse_:_Installation_:_Installing_the_DBG_Debugger">http://www.plog4u.org/</a>', E_USER_ERROR);
  }
 }
 
 function write_spacer($x = '')
  {
    echo "<hr>$x<br>";
    flush();
  }
  
  /**
   * A debug method.
   * Use to print contents of an array and gives an indication
   * of where dbg() was called
   * 
   * @todo 
   * - add support for object debugging
   * - have default $lable parameter be the name of $param passed in
   * 
   * @param mixed $array the item to debug
   * @param string $label optional html to label the $array
   * @param string $bt whethor or not to enable back trace
   * 
   * */
  function dbg($array, $label = '-', $bt = false)
  {
    $backtrace_string = '';
    if ($bt)
    {
      $backtraces = debug_backtrace();
      $backtrace_string = '';
      $first_run = true;
      
      foreach ($backtraces as $backtrace)
      {                
            $backtrace_string .= '<strong>line '.$backtrace['line']. '</strong>  calls function <strong>';
            $backtrace_string .= $backtrace['function'].'()</strong> in ';
            $backtrace_string .= '<span style="font-size: 9pt;">'.$backtrace['file'].'</span><br />';
      }
    }
            
    echo '<hr /><div style="pmsg"><strong>'. $label . '</strong><br />';       
    echo '<div class="arrayDebug" ><pre>';
    print_r($array);
    echo '</pre></div>' ;
    echo     "<em>" ;
    echo      $backtrace_string;
    echo     '</em></div>';
    flush();
        
  }
  
  function ArrayDepth($Array,$DepthCount=-1,$DepthArray=array()) 
  {
    $DepthCount++;
    if (is_array($Array))
     foreach ($Array as $Key => $Value)
       $DepthArray[]=ArrayDepth($Value,$DepthCount);
    else
     return $DepthCount;
    foreach($DepthArray as $Value)
     $Depth=$Value>$DepthCount?$Value:$DepthCount;
    return $Depth;
  }
    
  function make_seed()
  {
     list($usec, $sec) = explode(' ', microtime());
     return (float) $sec + ((float) $usec * 100000);
  }  
  
// from php.net e dot a dot schultz at gmail dot com  
if( !function_exists('memory_get_usage') )
{
   function memory_get_usage()
   {
       //If its Windows
       //Tested on Win XP Pro SP2. Should work on Win 2003 Server too
       //Doesn't work for 2000
       //If you need it to work for 2000 look at http://us2.php.net/manual/en/function.memory-get-usage.php#54642
       if ( substr(PHP_OS,0,3) == 'WIN')
       {
               if ( substr( PHP_OS, 0, 3 ) == 'WIN' ){
               $output = array();
               exec( 'tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output );
      
               if (isset($output[5]) )return preg_replace( '/[\D]/', '', $output[5] ) * 1024;   
               }        
       }
       else if (function_exists('exec'))
       {
           //We now assume the OS is UNIX
           //Tested on Mac OS X 10.4.6 and Linux Red Hat Enterprise 4
           //This should work on most UNIX systems
           $pid = getmypid();
           $output = array();
           exec("ps -eo%mem,rss,pid | grep $pid", $output);
           $output = explode("  ", $output[0]);
           //rss is given in 1024 byte units
           return $output[1] * 1024;
       }
   }
}
 
function this_microtime()
{
   list($usec, $sec) = explode(" ", microtime());
   return ((float)$usec + (float)$sec);
}
 
function sonia_test_output_results($all_test_results, $type = 'tabbed')
{
  $output = '';
  $first_row = ''; 
  
  switch($type)
  {
    case 'excel':
      
      break;
    case 'pretty':
      break;
    case 'tabbed':
    default:
      //firefox preserves state here unless name changes
      $start =  '<h2>Copy and paste below into excel</h2><textarea name="'.time().'" cols="100" rows="40" >'."\n";
      $end =  '</textarea>';
      $first_row .= "Test Group\tTest\tNumber of Objects\tNumber of Classes\tTime\tSubtitle\tComment\tMemory\tSuccess";
      
      foreach ($all_test_results as $title => $data)
      {
        $output .= "\n".SONIA_TEST_NAME."\t$title\t".SONIA_TEST_NUMBER_OF_OBJECTS."\t".SONIA_TEST_NUMBER_OF_CLASSESS.""; 
        foreach($data as $name =>$value)
        {
           sonia_clean_output($value);
           //sonia_clean_output($name);
           $output .= "\t".$value;
        }
      }
      
      echo $start;
      echo $first_row."\n";
      echo $output."\n";
      echo $end;
     
    
      break;
  }
}

function sonia_clean_output(&$op)
{
  $op = str_replace("\n",'  ',$op);
  $op = str_replace("\r",'  ',$op);
  $op = str_replace("\t",' ',$op);
}

////////////////////////////////////////////////////////////////////////////////
 // Drupal dummy functions
 // could produce flaw in tests
  /**
  * replaces Drupal cache function
  * */
 // function (){}

 function db_set_active(){}
 function cache_get($key) 
 {
   if(isset($_SESSION[$key])) return unserialize(base64_decode($_SESSION[$key]));
   return null;
 }
 
 function cache_set($key, $value)
 {
   $_SESSION[$key] = base64_encode(serialize($value));
 } 
 
 
 
 
?>